
doom = {}

doom.ViewOffset = Vector(0,0,0)

function doom.GetColor(pos)
	local col = render.GetLightColor(pos)
	col.r = math.Clamp(col.r+0.1,0.1,1)
	col.g = math.Clamp(col.g+0.1,0.1,1)
	col.b = math.Clamp(col.b+0.1,0.1,1)
	return col
end

language.Add("Battery_ammo","Energy Cell")
language.Add("npc_cyberdemon","Cyberdemon")

local colwhite = Color(255,255,255,255)

killicon.Add("doom_bfg9000","sprites/doom/w_bfg_menu",colwhite)
killicon.Add("doom_pistol","sprites/doom/w_pistol2",colwhite)
killicon.Add("doom_pistol_npc","sprites/doom/w_pistol2",colwhite)
killicon.Add("doom_chaingun","sprites/doom/w_chaingun_menu",colwhite)
killicon.Add("doom_chaingun_npc","sprites/doom/w_chaingun_menu",colwhite)
killicon.Add("doom_chainsaw","sprites/doom/w_chainsaw_menu",colwhite)
killicon.Add("doom_fists","sprites/doom/DG1Grin",colwhite)
killicon.Add("doom_fists_npc","sprites/doom/DG1Grin",colwhite)
killicon.Add("doom_plasmagun","sprites/doom/w_plasmagun_menu",colwhite)
killicon.Add("doom_plasmagun_npc","sprites/doom/w_plasmagun_menu",colwhite)
killicon.Add("doom_rocketlauncher","sprites/doom/w_RLauncher_menu",colwhite)
killicon.Add("doom_rocketlauncher_npc","sprites/doom/w_RLauncher_menu",colwhite)
killicon.Add("doom_shotgun","sprites/doom/w_shotgun_menu",colwhite)
killicon.Add("doom_shotgun_npc","sprites/doom/w_shotgun_menu",colwhite)
killicon.Add("doom_supershotgun","sprites/doom/w_shotgun2_menu",colwhite)
killicon.Add("doom_supershotgun_npc","sprites/doom/w_shotgun2_menu",colwhite)
killicon.Add("doom_projectile_rocket","sprites/doom/w_RLauncher_menu",colwhite)
killicon.Add("bfg_shot","sprites/doom/bfg_shot",colwhite)
killicon.Add("doom_barrel","sprites/doom/barrel",colwhite)

local players = FindMetaTable("Player")
	players.lastmovetime = 0

CreateClientConVar("cl_doom_lockview",0,true,false)	
	
local function gunsway(movedata)
	LocalPlayer().sway = LocalPlayer().sway or 0
	LocalPlayer().lastswaycalc = LocalPlayer().lastswaycalc or SysTime()
	local move = math.Max(math.abs(movedata:GetForwardMove()),math.abs(movedata:GetSideMove()))
	LocalPlayer().sway = LocalPlayer().sway+move/4000*(SysTime()-LocalPlayer().lastswaycalc)
	players.lastmovetime = math.Clamp(players.lastmovetime,SysTime()-0.25,SysTime())
	if move != 0 then
		players.lastmovetime =  math.Approach(players.lastmovetime,SysTime(),0.02)
	end
	//if LocalPlayer().sway > 10000 then
	//	LocalPlayer().sway = LocalPlayer().sway-10000
	//end
	if GetConVarNumber("cl_doom_lockview") == 1 then
		movedata:SetViewAngles(Angle(0,movedata:GetViewAngles().y,0))
	end
	LocalPlayer().lastswaycalc = SysTime()
end

hook.Add("CreateMove","gunsway",gunsway)


 
//hook.Add("CalcView", "headbob", headbob)

darkmat = Material("sprites/DOOM/pixel")
CreateClientConVar("cl_doom_fog",0,true,false)
local function drawfog()
	if GetConVarNumber("cl_doom_fog") == 1 then
		cam.Start3D(EyePos(),EyeAngles())
		render.SetMaterial(darkmat)
		render.DrawSprite(EyePos()+EyeVector()*200,1000,1000,Color(0,0,0,150))
		render.DrawSprite(EyePos()+EyeVector()*400,1000,1000,Color(0,0,0,145))
		render.DrawSprite(EyePos()+EyeVector()*800,10000,10000,Color(0,0,0,140))
		render.DrawSprite(EyePos()+EyeVector()*1600,10000,10000,Color(0,0,0,130))
		render.DrawSprite(EyePos()+EyeVector()*3200,10000,10000,Color(0,0,0,120))
		render.DrawSprite(EyePos()+EyeVector()*6400,20000,10000,Color(0,0,0,110))
		//render.DrawSprite(EyePos()+EyeVector()*12800,20000,10000,Color(0,0,0,100))
		cam.End3D()
	end
end

hook.Add("RenderScreenspaceEffects","doomfog",drawfog)

hook.Add("PlayerBindPress","doomusegrunt",function(pl,bind,pressed)
	if pressed && (bind == "+use") && pl:GetActiveWeapon():IsValid() && string.find(pl:GetActiveWeapon():GetClass(),"doom") && (pl:GetEyeTraceNoCursor().Entity == Entity(0)) && (pl:GetEyeTraceNoCursor().StartPos:Distance(pl:GetEyeTraceNoCursor().HitPos) < 64) then
		pl:EmitSound("doom/DSNOWAY.wav")
	end
end)

CreateClientConVar("cl_doom_plasma_additive",1,true,false)

if GetConVarNumber("cl_doom_plasma_additive") == 0 then
	doom.plasma = Material("sprites/DOOM/plasma1")
	doom.plasmaimpact = Material("sprites/DOOM/plasmaimpact1")
else
	doom.plasma = Material("sprites/DOOM/plasma_additive")
	doom.plasmaimpact = Material("sprites/DOOM/plasmaimpact_additive")
end

local function plasmaadditive(CVar,PreviousValue,NewValue)
	if NewValue == "0" then
		doom.plasma = Material("sprites/DOOM/plasma1")
		doom.plasmaimpact = Material("sprites/DOOM/plasmaimpact1")
	else
		doom.plasma = Material("sprites/DOOM/plasma_additive")
		doom.plasmaimpact = Material("sprites/DOOM/plasmaimpact_additive")
	end
end
cvars.AddChangeCallback("cl_doom_plasma_additive",plasmaadditive)

if SinglePlayer() then
	function doom.cl_fire()
		if LocalPlayer():GetActiveWeapon() && LocalPlayer():GetActiveWeapon():IsValid() && LocalPlayer():GetActiveWeapon().DoShootAnim then
			LocalPlayer():GetActiveWeapon():DoShootAnim()
		end
	end
	usermessage.Hook("d_cl_fire",doom.cl_fire)
end

local charconvert = {}
charconvert["!"] = 0
charconvert["\""] = 1
charconvert["#"] = 2
charconvert["$"] = 3
charconvert["%"] = 4
charconvert["&"] = 5
charconvert["'"] = 6
charconvert["("] = 7
charconvert[")"] = 8
charconvert["*"] = 9
charconvert["+"] = 10
charconvert[","] = 11
charconvert["-"] = 12
charconvert["."] = 13
charconvert["/"] = 14
charconvert["0"] = 15
charconvert["1"] = 16
charconvert["2"] = 17
charconvert["3"] = 18
charconvert["4"] = 19
charconvert["5"] = 20
charconvert["6"] = 21
charconvert["7"] = 22
charconvert["8"] = 23
charconvert["9"] = 24
charconvert[":"] = 25
charconvert[";"] = 26
charconvert["<"] = 27
charconvert["="] = 28
charconvert[">"] = 29
charconvert["?"] = 30
charconvert["@"] = 31
charconvert["A"] = 32
charconvert["B"] = 33
charconvert["C"] = 34
charconvert["D"] = 35
charconvert["E"] = 36
charconvert["F"] = 37
charconvert["G"] = 38
charconvert["H"] = 39
charconvert["I"] = 40
charconvert["J"] = 41
charconvert["K"] = 42
charconvert["L"] = 43
charconvert["M"] = 44
charconvert["N"] = 45
charconvert["O"] = 46
charconvert["P"] = 47
charconvert["Q"] = 48
charconvert["R"] = 49
charconvert["S"] = 50
charconvert["T"] = 51
charconvert["U"] = 52
charconvert["V"] = 53
charconvert["W"] = 54
charconvert["X"] = 55
charconvert["Y"] = 56
charconvert["Z"] = 57
charconvert["["] = 58
charconvert["\\"] = 59
charconvert["]"] = 60
charconvert["^"] = 61
charconvert["_"] = 62

local specialwidth = {}
specialwidth["I"] = 4
specialwidth["'"] = 4
specialwidth["1"] = 5
specialwidth["4"] = 7
specialwidth["5"] = 7
specialwidth["@"] = 9
specialwidth["["] = 5
specialwidth["]"] = 5
specialwidth["<"] = 5
specialwidth["="] = 5
specialwidth[">"] = 5
specialwidth["-"] = 6
specialwidth["%"] = 9
specialwidth["|"] = 4
specialwidth["+"] = 5
specialwidth["W"] = 9
specialwidth["X"] = 10
specialwidth[" "] = 6

local doomfont = Material("vgui/doom/doomfont")
local doomfonttex = surface.GetTextureID("vgui/doom/doomfont")
local function drawdoomtext(x,y,text)
	surface.SetDrawColor(255,255,255,255)
	surface.SetTexture(doomfonttex)
	local xpos = 0
	for i=1,string.len(text),1 do
		local char = string.sub(text,i,i)
		if charconvert[char] then
			doomfont:SetMaterialInt("$frame",charconvert[char])
			surface.DrawTexturedRect(x+xpos,y,16,8)
		end
		if specialwidth[char] then
			xpos = xpos+specialwidth[char]
		else
			xpos = xpos+8
		end
	end
end

local itemnotifications = {}
local itemremoves = {}
hook.Add("HUDPaint","dnotify",function()
	for k,v in ipairs(itemnotifications) do
		drawdoomtext(0,k*8-8,v.Text)
		if v.Created+4 < CurTime() then
			table.remove(itemnotifications,k)
		end
	end
end)
	

local ITEM_FISTS			= 0
local ITEM_PISTOL			= 1
local ITEM_SHOTGUN			= 2
local ITEM_SUPERSHOTGUN 	= 3
local ITEM_CHAINGUN			= 4
local ITEM_ROCKETLAUNCHER 	= 5
local ITEM_PLASMAGUN		= 6
local ITEM_BFG9000			= 7
local ITEM_CHAINSAW			= 8
local ITEM_AMMO_BULLETSMALL = 9
local ITEM_AMMO_BULLETLARGE = 10
local ITEM_AMMO_SHELLSSMALL = 11
local ITEM_AMMO_SHELLSLARGE = 12
local ITEM_AMMO_ROCKETSMALL = 13
local ITEM_AMMO_ROCKETLARGE = 14
local ITEM_AMMO_CELLSSMALL	= 15
local ITEM_AMMO_CELLSLARGE	= 16
local ITEM_BERSERK			= 17
local ITEM_STIMPACK			= 18
local ITEM_MEDIKIT			= 19
local ITEM_ARMOR			= 20
local ITEM_MEGAARMOR		= 21
local ITEM_HEALTHBONUS		= 22
local ITEM_ARMORBONUS		= 23
local ITEM_SUPERCHARGE		= 24
local ITEM_MEGASPHERE		= 25
local ITEM_INVULNERABILITY	= 26
local ITEM_BACKPACK			= 27
local ITEM_LIGHTAMP			= 28
local ITEM_BLURARTIFACT		= 29
local ITEM_RADIATIONSUIT	= 30
local ITEM_AUTOMAP			= 31

local itemtexts = {}
//itemtexts[ITEM_FISTS]				= "YOU FOUND YOUR HANDS, GOOD JOB SOLDIER."
//itemtexts[ITEM_PISTOL]			= "YOU GOT THE PISTOL!"
itemtexts[ITEM_SHOTGUN]				= "YOU GOT THE SHOTGUN!"
itemtexts[ITEM_SUPERSHOTGUN] 		= "YOU GOT THE SUPER SHOTGUN!"
itemtexts[ITEM_CHAINGUN]			= "YOU GOT THE CHAINGUN!"
itemtexts[ITEM_ROCKETLAUNCHER]		= "YOU GOT THE ROCKET LAUNCHER!"
itemtexts[ITEM_PLASMAGUN]			= "YOU GOT THE PLASMA GUN!"
itemtexts[ITEM_BFG9000]				= "YOU GOT THE BFG9000! OH, YES."
itemtexts[ITEM_CHAINSAW]			= "A CHAINSAW! FIND SOME MEAT!"
itemtexts[ITEM_AMMO_BULLETSMALL]	= "PICKED UP A CLIP."
itemtexts[ITEM_AMMO_BULLETLARGE]	= "PICKED UP A BOX OF BULLETS."
itemtexts[ITEM_AMMO_SHELLSSMALL]	= "PICKED UP 4 SHOTGUN SHELLS."
itemtexts[ITEM_AMMO_SHELLSLARGE]	= "PICKED UP A BOX OF SHOTGUN SHELLS."
itemtexts[ITEM_AMMO_ROCKETSMALL]	= "PICKED UP A ROCKET."
itemtexts[ITEM_AMMO_ROCKETLARGE]	= "PICKED UP A BOX OF ROCKETS."
itemtexts[ITEM_AMMO_CELLSSMALL]		= "PICKED UP AN ENERGY CELL."
itemtexts[ITEM_AMMO_CELLSLARGE]		= "PICKED UP AN ENERGY CELL PACK."
itemtexts[ITEM_BERSERK]				= "BERSERK!"
itemtexts[ITEM_STIMPACK]			= "PICKED UP A STIMPACK."
itemtexts[ITEM_MEDIKIT]				= "PICKED UP A MEDIKIT."
itemtexts[ITEM_ARMOR]				= "PICKED UP THE ARMOR."
itemtexts[ITEM_MEGAARMOR]			= "PICKED UP THE MEGAARMOR!"
itemtexts[ITEM_HEALTHBONUS]			= "PICKED UP A HEALTH BONUS."
itemtexts[ITEM_ARMORBONUS]			= "PICKED UP AN ARMOR BONUS."
itemtexts[ITEM_SUPERCHARGE]			= "SUPERCHARGE!"
itemtexts[ITEM_MEGASPHERE]			= "MEGASPHERE!"
itemtexts[ITEM_INVULNERABILITY]		= "INVULNERABILITY!"
itemtexts[ITEM_BACKPACK]			= "PICKED UP A BACKPACK FULL OF AMMO!"
itemtexts[ITEM_LIGHTAMP]			= "LIGHT AMPLIFICATION VISOR"
itemtexts[ITEM_BLURARTIFACT]		= "PARTIAL INVISIBILITY"
itemtexts[ITEM_RADIATIONSUIT]		= "RADIATION SHIELDING SUIT"
itemtexts[ITEM_AUTOMAP]				= "COMPUTER AREA MAP"

function doom.AddHUDText(text)
	text = string.upper(text)
	table.insert(itemnotifications,{["Created"] = CurTime(),["Text"] = text})
	Msg(text.."\n")
end

hook.Add("HUDWeaponPickedUp","dweapon",function(wep) return false end)
usermessage.Hook("DWPNUP",function(um) local text = itemtexts[um:ReadChar()] if !text then return end doom.AddHUDText(text) end)
//local inv = Material("effects/DOOM/colorinvert")
//hook.Add("RenderScreenspaceEffects","invert",function() render.SetMaterial(inv) render.DrawScreenQuad(inv) end)

--lightamp fix, if you have gm_cvar2 installed on your client it should work correctly for you instead of using dynamic light.
	require("cvar2")
	if cvar2 then
		cvar2.SetFlags("mat_fullbright",0)
		FullBrightEnabled = true
		//hook.Add("ShutDown","doom_fullbright",function() cvar2.ResetValue("mat_fullbright") end)
		hook.Add("InitPostEntity","doom_fullbright",function() cvar2.ResetValue("mat_fullbright") end)
	end