AddCSLuaFile("init.lua")
EFFECT.nextframe = 0
EFFECT.RBMin = Vector(-64,-64,-64)
EFFECT.RBMax = Vector(64,64,64)
local d_pl_fr = 0
EFFECT.blastmat = Material("sprites/DOOM/muzflare")

local hullmins = Vector(-5,-5,-5)
local hullmaxs = Vector(5,5,5)

function EFFECT:Init(data)
	self.flaretime = CurTime()+0.25
	self.Created = CurTime()
	if SinglePlayer() then
		self.Created = data:GetScale()
	end
	self.vel = data:GetStart()
	self.Owner = data:GetEntity()
		self.frame = d_pl_fr
	self.lasttrace = self.Created
	self.time = CurTime()+0.4
	if !self.Owner || !self.Owner:IsValid() then
		self.nothink = true
		return false
	end
	self.Owner:EmitSound("DOOM/DSPLASMA.wav",100,100)
	self:SetRenderBounds(self.RBMin,self.RBMax)
	d_pl_fr = 1-d_pl_fr
end

function EFFECT:Think()
	if self.nothin then
		return false
	end
	local vel = self.vel*math.max(0,CurTime()-self.lasttrace)
	if CurTime() > self.Created+0.025 then
		local tracep = {}
		tracep.start = self:GetPos()
		tracep.mask = MASK_SHOT
		tracep.filter = self.Owner
		tracep.endpos = self:GetPos()+vel
		tracep.mins = hullmins
		tracep.maxs = hullmaxs
		tr = util.TraceHull(tracep)
		if tr.Hit then
			WorldSound("DOOM/DSFIRXPL.wav",tr.HitPos,150,100)
			//self:EmitSound("DOOM/DSFIRXPL.wav",35,100)
			local edata = EffectData()
			edata:SetOrigin(self:GetPos())
			util.Effect("sprite_pl_imp",edata)
			return false
		end
	end
	self.lasttrace = CurTime()
	self:SetPos(self:GetPos()+vel)
	
	return true
end

function EFFECT:Render()
	if self.Owner && self.Owner:IsValid() && self.Owner.GetActiveWeapon && self.Owner:GetActiveWeapon():IsValid() && (CurTime() < self.flaretime) && (GetViewEntity() != self.Owner) then
		render.SetMaterial(self.blastmat)
		render.DrawSprite(self.Owner:GetActiveWeapon():GetAttachment(self.Owner:GetActiveWeapon():LookupAttachment("muzzle")).Pos,32,32,Color(255,168,100,255))
	end
	if self.Created+0.00 > CurTime() then
		return
	end
	if self.nextframe < CurTime() then
		self.frame = 1-self.frame
		self.nextframe = CurTime()+0.2
	end
	doom.plasma:SetMaterialInt("$frame",self.frame)
	doom.plasma:SetMaterialInt("$additive",GetConVarNumber("cl_doom_plasma_additive"))
	render.SetMaterial(doom.plasma)
	render.DrawSprite(self:GetPos(),32,32,Color(255,255,255,128))
end