AddCSLuaFile("init.lua")
EFFECT.gravi = Vector(0,0,-4)
EFFECT.risei = Vector(0,0,0.5)
EFFECT.mat1 = Material("sprites/DOOM/blood")
EFFECT.mat2 = Material("sprites/DOOM/puff")
EFFECT.blastmat = Material("sprites/DOOM/muzflare")
EFFECT.wep = NULL
local mapmins = Vector(-20480,-20480,-20480)
local mapmaxs = Vector(20480,20480,20480)

function EFFECT:Init(data)
	self.flaretime = CurTime()+0.25
	self.parts = {}
	self.partb = {}
	self.grav = Vector(0,0,0)
	self.rise = Vector(0,0,0)
	self.Owner = data:GetEntity()
	if !self.Owner:IsValid() then
		return false
	end
	self.Owner:EmitSound("DOOM/DSSHOTGN.wav",100,100)
	local owner = self.Owner
	self.time = CurTime()+0.75
	local tracep = {}
	local right
	local pos
	local dir
	if self.Owner:IsPlayer() then
		tracep.start = self.Owner:GetShootPos()
		right = self.Owner:GetAimVector():Angle():Right()
		self.wep = self.Owner:GetActiveWeapon()
		dir = self.Owner:GetAimVector()
		pos = self.Owner:GetShootPos()
	else
		local weps = ents.GetAll()
		for k,v in ipairs(weps) do
			if v:IsWeapon() && (v:GetOwner() == self.Owner) then
				self.wep = v
				break
			end
		end
		dir = data:GetNormal()
		pos = data:GetOrigin()
		right = data:GetNormal():Angle():Right()
	end

	tracep.filter = self.Owner
	tracep.mask = MASK_SHOT

	for i=1,7 do
		local tr = {}
		if self.Owner:IsPlayer() then
			local dir2 = (dir+right*math.Rand(-0.1,0.1)):GetNormalized()
			tracep.start = self.Owner:GetShootPos()
			tracep.endpos = self.Owner:GetShootPos()+(dir2*4096)
		else
			local dir2 = (dir+right*math.Rand(-0.1,0.1)):GetNormalized()
			tracep.start = self:GetPos()
			tracep.endpos = self:GetPos()+(dir2*4096)
		end
		tr = util.TraceLine(tracep)
		
		if tr.Hit then
			if tr.Entity && tr.Entity:IsValid() && (tr.Entity:IsPlayer() || tr.Entity:IsNPC()) then
				table.insert(self.partb,tr.HitPos)
			elseif !tr.HitSky then
				table.insert(self.parts,tr.HitPos)
			end
		end
	end
	self:SetRenderBoundsWS(mapmins,mapmaxs)
end

function EFFECT:Think()
	if !self.Owner:IsValid() then
		return false
	end
	self.grav = self.grav+self.gravi
	self.rise = self.rise+self.risei
	if self.time > CurTime() then
		return true
	end
	return false
end

function EFFECT:Render()
	if !self.Owner:IsValid() then
		return false
	end
	if self.wep:IsValid() && (CurTime() < self.flaretime) && (GetViewEntity() != self.Owner) then
		render.SetMaterial(self.blastmat)
		render.DrawSprite(self.wep:GetAttachment(self.wep:LookupAttachment("muzzle")).Pos,32,32,Color(255,168,100,255))
	end
	render.SetMaterial(self.mat1)
	self.mat1:SetMaterialInt("$frame",math.Clamp(math.floor(3-(self.time-CurTime())*4),0,2))
	for k,v in ipairs(self.partb) do
		render.DrawSprite(v+self.grav,16,16,Color(255,255,255,128))
	end
	if self.time > CurTime()+0.35 then
		render.SetMaterial(self.mat2)
		self.mat2:SetMaterialInt("$frame",math.Clamp(math.floor(4-(self.time-CurTime()-0.35)*10),0,3))
		for k,v in ipairs(self.parts) do
			render.DrawSprite(v+self.rise,16,16,Color(255,255,255,128))
		end
	end
end