local ammocaps = {}
ammocaps["Pistol"] = 200
ammocaps["Buckshot"] = 50
ammocaps["RPG_Round"] = 50
ammocaps["Battery"] = 300

local function GenericSpawnfunction(self,ply,tr)
	local ent = ents.Create(self.ClassName)
	ent:SetPos(tr.HitPos+Vector(0,0,16))
	ent.HasPhysics = true
	ent:Spawn()
	ent:GetPhysicsObject():SetVelocity(Vector(0,0,200))
	return ent
end

//================================================//
// Armor Bonus
//================================================//
local ENT = {}
	ENT.Type = "anim"
	ENT.PrintName = "Armor Bonus"
	ENT.Spawnable = true
	ENT.AdminSpawnable = true
	ENT.Category = "DOOM items"
	ENT.Base = "doom_pickup_base"
	ENT.SpawnFunction = GenericSpawnfunction
	ENT.TouchFunc = function(self,pl)
		if pl:Armor() < 200 then
			pl:SetArmor(pl:Armor()+1)
		end
		DOOM_sendpickup(pl,"doom_armorbonus")
		pl:EmitSound("DOOM/DSITEMUP.wav")
		return true
	end
	scripted_ents.Register(ENT,"doom_armorbonus")

//================================================//
// Health Bonus
//================================================//
local ENT = {}
	ENT.Type = "anim"
	ENT.PrintName = "Health Bonus"
	ENT.Spawnable = true
	ENT.AdminSpawnable = true
	ENT.Category = "DOOM items"
	ENT.Base = "doom_pickup_base"
	ENT.SpawnFunction = GenericSpawnfunction
	ENT.TouchFunc = function(self,pl)
		if pl:Health() < 200 then
			pl:SetHealth(pl:Health()+1)
		end
		DOOM_sendpickup(pl,"doom_healthbonus")
		pl:EmitSound("DOOM/DSITEMUP.wav")
		return true
	end
	scripted_ents.Register(ENT,"doom_healthbonus")
	
//================================================//
// Armor
//================================================//
local ENT = {}
	ENT.Type = "anim"
	ENT.PrintName = "Armor"
	ENT.Spawnable = true
	ENT.AdminSpawnable = true
	ENT.Category = "DOOM items"
	ENT.Base = "doom_pickup_base"
	ENT.SpawnFunction = GenericSpawnfunction
	ENT.TouchFunc = function(self,pl)
		if pl:Armor() < 100 then
			pl:SetArmor(100)
			DOOM_sendpickup(pl,"doom_armor")
			pl:EmitSound("DOOM/DSITEMUP.wav")
			return true
		end
	end
	scripted_ents.Register(ENT,"doom_armor")
	
//================================================//
// Megaarmor
//================================================//
local ENT = {}
	ENT.Type = "anim"
	ENT.PrintName = "Megaarmor"
	ENT.Spawnable = false
	ENT.AdminSpawnable = true
	ENT.Category = "DOOM items"
	ENT.Base = "doom_pickup_base"
	ENT.SpawnFunction = GenericSpawnfunction
	ENT.TouchFunc = function(self,pl)
		if pl:Armor() < 200 then
			pl:SetArmor(200)
			DOOM_sendpickup(pl,"doom_megaarmor")
			pl:EmitSound("DOOM/DSITEMUP.wav")
			return true
		end
	end
	scripted_ents.Register(ENT,"doom_megaarmor")
	
//================================================//
// Stimpack
//================================================//
local ENT = {}
	ENT.Type = "anim"
	ENT.PrintName = "Stimpack"
	ENT.Spawnable = true
	ENT.AdminSpawnable = true
	ENT.Category = "DOOM items"
	ENT.Base = "doom_pickup_base"
	ENT.SpawnFunction = GenericSpawnfunction
	ENT.TouchFunc = function(self,pl)
		if pl:Health() < 100 then
			pl:SetHealth(math.min(pl:Health()+10,100))
			DOOM_sendpickup(pl,"doom_stimpack")
			pl:EmitSound("DOOM/DSITEMUP.wav")
			return true
		end
	end
	scripted_ents.Register(ENT,"doom_stimpack")
	
//================================================//
// Medikit
//================================================//
local ENT = {}
	ENT.Type = "anim"
	ENT.PrintName = "Medikit"
	ENT.Spawnable = true
	ENT.AdminSpawnable = true
	ENT.Category = "DOOM items"
	ENT.Base = "doom_pickup_base"
	ENT.SpawnFunction = GenericSpawnfunction
	ENT.TouchFunc = function(self,pl)
		if pl:Health() < 100 then
			pl:SetHealth(math.min(pl:Health()+25,100))
			DOOM_sendpickup(pl,"doom_medikit")
			pl:EmitSound("DOOM/DSITEMUP.wav")
			return true
		end
	end
	scripted_ents.Register(ENT,"doom_medikit")
	
//================================================//
// Megasphere
//================================================//
local ENT = {}
	ENT.Type = "anim"
	ENT.PrintName = "Megasphere"
	ENT.Spawnable = false
	ENT.AdminSpawnable = true
	ENT.Category = "DOOM items"
	ENT.Base = "doom_pickup_base"
	ENT.SpawnFunction = GenericSpawnfunction
	ENT.Mins = Vector(-14,-14,-14)
	ENT.Maxs = Vector(14,14,14)
	ENT.TouchFunc = function(self,pl)
		if pl:Health() < 200 then
			pl:SetHealth(200)
		end
		if pl:Armor() < 200 then
			pl:SetArmor(200)
		end
		DOOM_sendpickup(pl,"doom_megasphere")
		pl:EmitSound("DOOM/DSGETPOW.wav")
		return true
	end
	scripted_ents.Register(ENT,"doom_megasphere")

//================================================//
// Supercharge
//================================================//
local ENT = {}
	ENT.Type = "anim"
	ENT.PrintName = "Supercharge"
	ENT.Spawnable = false
	ENT.AdminSpawnable = true
	ENT.Category = "DOOM items"
	ENT.Base = "doom_pickup_base"
	ENT.SpawnFunction = GenericSpawnfunction
	ENT.Mins = Vector(-14,-14,-14)
	ENT.Maxs = Vector(14,14,14)
	ENT.TouchFunc = function(self,pl)
		if pl:Health() < 200 then
			pl:SetHealth(math.min(pl:Health()+100,200))
		end
		DOOM_sendpickup(pl,"doom_supercharge")
		pl:EmitSound("DOOM/DSGETPOW.wav")
		return true
	end
	scripted_ents.Register(ENT,"doom_supercharge")

//================================================//
// Backpack
//================================================//
local ENT = {}
	ENT.Type = "anim"
	ENT.PrintName = "Backpack"
	ENT.Spawnable = true
	ENT.AdminSpawnable = true
	ENT.Category = "DOOM items"
	ENT.Base = "doom_pickup_base"
	ENT.SpawnFunction = GenericSpawnfunction
	ENT.Mins = Vector(-14,-14,-14)
	ENT.Maxs = Vector(14,14,14)
	ENT.TouchFunc = function(self,pl)
		if GetConVarNumber("sv_doom_backpackstyle") == 1 then
			pl:GiveAmmo(30,"AR2",true)
			pl:GiveAmmo(18,"Pistol",true)
			pl:GiveAmmo(45,"SMG1",true)
			pl:GiveAmmo(6,"357",true)
			pl:GiveAmmo(2,"XBowBolt",true)
			pl:GiveAmmo(6,"Buckshot",true)
			pl:GiveAmmo(1,"RPG_Round",true)
			pl:GiveAmmo(1,"SMG1_Grenade",true)
			pl:GiveAmmo(2,"Grenade",true)
			pl:GiveAmmo(1,"AR2AltFire",true)
			pl:GiveAmmo(2,"slam",true)
		else
			pl.DOOM_HasBackPack = true
			self.GiveAmmoWithCap(pl,"Pistol",10)
			self.GiveAmmoWithCap(pl,"Buckshot",4)
			self.GiveAmmoWithCap(pl,"RPG_Round",1)
			self.GiveAmmoWithCap(pl,"Battery",20)
		end
		DOOM_sendpickup(pl,"doom_backpack")
		pl:EmitSound("DOOM/DSITEMUP.wav")
		return true
	end
	scripted_ents.Register(ENT,"doom_backpack")
	hook.Add("PlayerDeath","DOOM_nobackpack",function(pl) pl.DOOM_HasBackPack = false pl.D_Berserk = false end)
	CreateConVar("sv_doom_backpackstyle",0,FCVAR_ARCHIVE) --if set to 1, the backpack gives ammo based on HL2 weapons

//================================================//
// Berserk Pack
//================================================//
local ENT = {}
	ENT.Type = "anim"
	ENT.PrintName = "Berserk Pack"
	ENT.Spawnable = false
	ENT.AdminSpawnable = true
	ENT.Category = "DOOM items"
	ENT.Base = "doom_pickup_base"
	ENT.SpawnFunction = GenericSpawnfunction
	ENT.TouchFunc = function(self,pl)
		if pl:Health() < 100 then
			pl:SetHealth(100)
		end
		pl.D_Berserk = true
		DOOM_sendpickup(pl,"doom_berserk")
		pl:EmitSound("DOOM/DSGETPOW.wav")
		pl:Give("doom_fists")
		pl:SelectWeapon("doom_fists")
		umsg.Start("d_bers",pl)
			umsg.Char(20)
		umsg.End()
		return true
	end
	scripted_ents.Register(ENT,"doom_berserk")

//================================================//
// Invulnerability
//================================================//
local ENT = {}
	ENT.Type = "anim"
	ENT.PrintName = "Invulnerability"
	ENT.Spawnable = false
	ENT.AdminSpawnable = true
	ENT.Category = "DOOM items"
	ENT.Base = "doom_pickup_base"
	ENT.SpawnFunction = GenericSpawnfunction
	ENT.Mins = Vector(-14,-14,-14)
	ENT.Maxs = Vector(14,14,14)
	ENT.TouchFunc = function(self,pl)
		pl.D_InvulnTime = CurTime()+30
		DOOM_sendpickup(pl,"doom_invulnerability")
		pl:EmitSound("DOOM/DSGETPOW.wav")
		umsg.Start("d_inv",pl)
			umsg.Char(30)
		umsg.End()
		return true
	end
	scripted_ents.Register(ENT,"doom_invulnerability")

//================================================//
// Radiation Shielding Suit
//================================================//
local ENT = {}
	ENT.Type = "anim"
	ENT.PrintName = "Radiation Shielding Suit"
	ENT.Spawnable = false
	ENT.AdminSpawnable = true
	ENT.Category = "DOOM items"
	ENT.Base = "doom_pickup_base"
	ENT.SpawnFunction = GenericSpawnfunction
	ENT.TouchFunc = function(self,pl)
		pl.D_RadSuitTime = CurTime()+60
		DOOM_sendpickup(pl,"doom_radiationsuit")
		pl:EmitSound("DOOM/DSITEMUP.wav")
		umsg.Start("d_rad",pl)
			umsg.Char(60)
		umsg.End()
		return true
	end
	scripted_ents.Register(ENT,"doom_radiationsuit")
	hook.Add("PlayerSpawn","radsuitsetup",function(pl) pl.D_RadSuitTime = 0 pl.D_InvulnTime = 0 end)
	hook.Add("EntityTakeDamage","radsuit",function(ent,inflictor,attacker,amount,dmginfo)
		if ent:IsPlayer()
		&& ((((attacker:IsValid() && (attacker:GetClass() == "trigger_hurt")) || dmginfo:IsDamageType(DMG_RADIATION))
		&& (ent.D_RadSuitTime > CurTime())) || ((ent.D_InvulnTime > CurTime()) && (amount < 1000))) then
			ent:TakePhysicsDamage(dmginfo)
			return true
		end
	end)
	
//================================================//
// Light Amplification Visor
//================================================//
local ENT = {}
	ENT.Type = "anim"
	ENT.PrintName = "Light Amplification Visor"
	ENT.Spawnable = false
	ENT.AdminSpawnable = true
	ENT.Category = "DOOM items"
	ENT.Base = "doom_pickup_base"
	ENT.SpawnFunction = GenericSpawnfunction
	ENT.TouchFunc = function(self,pl)
		DOOM_sendpickup(pl,"doom_lightamp")
		pl:EmitSound("DOOM/DSITEMUP.wav")
		umsg.Start("d_lightamp",pl)
			umsg.Char(120)
		umsg.End()
		return true
	end
	scripted_ents.Register(ENT,"doom_lightamp")