local ammocaps = {}
ammocaps["Pistol"] = 200
ammocaps["Buckshot"] = 50
ammocaps["RPG_Round"] = 50
ammocaps["Battery"] = 300

local function TouchFuncGiveWeapon(self,pl)
	if !pl:GetWeapon(self.wtype):IsValid() then
		pl:Give(self.wtype)
		return true
	elseif self.atype && self.GivesAmmo && self.GiveAmmoWithCap(pl,self.atype,self.amount) then
		DOOM_sendpickup(pl,self.wtype)
		pl:EmitSound("DOOM/DSWPNUP.wav",75)
		return true
	end
	return false
end

//================================================//
// BFG9000
//================================================//
local ENT = {}
	ENT.Type = "anim"
	ENT.PrintName = "The BFG9000"
	ENT.Spawnable = false
	ENT.AdminSpawnable = false
	ENT.Base = "doom_pickup_base"
	ENT.atype = "Battery"
	if !GAMEMODE.Deathmatch then
		ENT.amount = 40
	else
		ENT.amount = 100
	end
	ENT.cap = 600
	ENT.wtype = "doom_bfg9000"
	ENT.TouchFunc = TouchFuncGiveWeapon
	
	local function bfg_duplicate(pl)
		pl:EmitSound("DOOM/DSNOWAY.wav")
		return false
	end
	duplicator.RegisterEntityClass("doom_wep_bfg9000",bfg_duplicate)
	scripted_ents.Register(ENT,"doom_wep_bfg9000")

//================================================//
// Chaingun
//================================================//
local ENT = {}
	ENT.Type = "anim"
	ENT.PrintName = "Chaingun"
	ENT.Spawnable = false
	ENT.AdminSpawnable = false
	ENT.Base = "doom_pickup_base"
	ENT.atype = "Pistol"
	if !(GAMEMODE.Deathmatch) then
		ENT.amount = 20
	else
		ENT.amount = 50
	end
	ENT.cap = 400
	ENT.wtype = "doom_chaingun"
	ENT.TouchFunc = TouchFuncGiveWeapon

	scripted_ents.Register(ENT,"doom_wep_chaingun")

//================================================//
// Chainsaw
//================================================//
local ENT = {}
	ENT.Type = "anim"
	ENT.PrintName = "Chainsaw"
	ENT.Spawnable = false
	ENT.AdminSpawnable = false
	ENT.Base = "doom_pickup_base"
	ENT.wtype = "doom_chainsaw"
	ENT.GivesAmmo = false
	ENT.TouchFunc = TouchFuncGiveWeapon

	scripted_ents.Register(ENT,"doom_wep_chainsaw")

//================================================//
// Pistol
//================================================//
local ENT = {}
	ENT.Type = "anim"
	ENT.PrintName = "Pistol"
	ENT.Spawnable = false
	ENT.AdminSpawnable = false
	ENT.Base = "doom_pickup_base"
	ENT.atype = "Pistol"
	if !GAMEMODE.Deathmatch then
		ENT.amount = 10
	else
		ENT.amount = 20
	end
	ENT.cap = 400
	ENT.wtype = "doom_pistol"
	ENT.TouchFunc = TouchFuncGiveWeapon

	scripted_ents.Register(ENT,"doom_wep_pistol")

//================================================//
// Plasma Gun
//================================================//
local ENT = {}
	ENT.Type = "anim"
	ENT.PrintName = "Plasma Gun"
	ENT.Spawnable = false
	ENT.AdminSpawnable = false
	ENT.Base = "doom_pickup_base"
	ENT.atype = "Battery"
	if !GAMEMODE.Deathmatch then
		ENT.amount = 20
	else
		ENT.amount = 100
	end
	ENT.cap = 600
	ENT.wtype = "doom_plasmagun"
	ENT.TouchFunc = TouchFuncGiveWeapon


	scripted_ents.Register(ENT,"doom_wep_plasmagun")

//================================================//
// Rocket Launcher
//================================================//
local ENT = {}
	ENT.Type = "anim"
	ENT.PrintName = "Rocket Launcher"
	ENT.Spawnable = false
	ENT.AdminSpawnable = false
	ENT.Base = "doom_pickup_base"
	ENT.atype = "RPG_Round"
	if !GAMEMODE.Deathmatch then
		ENT.amount = 2
	else
		ENT.amount = 5
	end
	ENT.cap = 100
	ENT.wtype = "doom_rocketlauncher"
	ENT.TouchFunc = TouchFuncGiveWeapon

	scripted_ents.Register(ENT,"doom_wep_rocketlauncher")

//================================================//
// Shotgun
//================================================//
local ENT = {}
	ENT.Type = "anim"
	ENT.PrintName = "Shotgun"
	ENT.Spawnable = false
	ENT.AdminSpawnable = false
	ENT.Base = "doom_pickup_base"
	ENT.atype = "Buckshot"
	if !GAMEMODE.Deathmatch then
		ENT.amount = 8
	else
		ENT.amount = 20
	end
	ENT.cap = 100
	ENT.wtype = "doom_shotgun"
	ENT.TouchFunc = TouchFuncGiveWeapon

	scripted_ents.Register(ENT,"doom_wep_shotgun")

//================================================//
// Super Shotgun
//================================================//
local ENT = {}
	ENT.Type = "anim"
	ENT.PrintName = "Super Shotgun"
	ENT.Spawnable = false
	ENT.AdminSpawnable = false
	ENT.Base = "doom_pickup_base"
	ENT.atype = "Buckshot"
	if !GAMEMODE.Deathmatch then
		ENT.amount = 8
	else
		ENT.amount = 20
	end
	ENT.cap = 100
	ENT.wtype = "doom_supershotgun"
	ENT.TouchFunc = TouchFuncGiveWeapon

	scripted_ents.Register(ENT,"doom_wep_sshotgun")