include('shared.lua')

ENT.nextframe = 0
ENT.frame = 0
ENT.internalframe = 1
ENT.metal = true

function ENT:Initialize()
	self.mat = Material("sprites/DOOM/Cyberdemon")
	self:SetCollisionBounds(Vector(-48,-48,-40),Vector(48,48,128))
	self:SetRenderBounds(Vector(-64,-64,0),Vector(64,64,300))
end

local walkframes = {}
walkframes[1] = 0
walkframes[2] = 1
walkframes[3] = 2
walkframes[4] = 1


function ENT:Think()
	if (self.dt.State == 1) && (self.nextframe < CurTime()) then
		if self.frame == 2 then
			self.nextframe = CurTime()+0.15
		else
			self.nextframe = CurTime()+0.15
		end
		self.internalframe = self.internalframe+1
		while self.internalframe > 4 do
			self.internalframe = self.internalframe-4
		end
		while self.internalframe < 1 do
			self.internalframe = self.internalframe+4
		end
		self.frame = walkframes[self.internalframe]
		if (self.frame == 0) && self.metal then
			self:EmitSound("DOOM/metal.wav")
			self.metal = false
			self.hoof = true
		elseif (self.frame == 2) && self.hoof then
			self:EmitSound("DOOM/hoof.wav")
			self.hoof = false
			self.metal = true
		end
	end
	if (self.dt.State == 2) then
		self.frame = 4
	end
	if (self.dt.State == 3) then
		self.frame = 5
	end
	if (self.dt.State == 4) then
		self.frame = 6
	end
end

local up = Vector(0,0,224)
local white = Vector(1,1,1)

function ENT:Draw()

	local right = EyeAngles():Right()*160
	local fr = math.Round(((GetViewEntity():GetPos()-self:GetPos()):Angle().y-self:GetAngles().y)/45)
	while fr > 7 do
		fr = fr-8
	end
	while fr < 0 do
		fr = fr+8
	end
	local col
	if self.dt.State == 3 then
		col = white
	else
		col = doom.GetColor(self:GetPos()+self:OBBCenter())
		col.x = math.Clamp(col.x+0.2,0,1)
		col.y = math.Clamp(col.y+0.2,0,1)
		col.z = math.Clamp(col.z+0.2,0,1)
	end
	self.mat:SetMaterialVector("$color",col)
	local pos = self:GetPos()
	if self.dt.State != 5 then
		fr = math.Clamp(fr,0,7)+(8*self.frame)
	else
		fr = math.Clamp(math.floor(64-(self.dt.DieAnimTime-CurTime())*7/2),56,64)
		pos.z = pos.z+19
	end
	self.mat:SetMaterialInt("$frame",fr)
	render.SetMaterial(self.mat)
		render.DrawQuad(pos-right+up,pos+right+up,pos+right,pos-right)
end