AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")
include('shared.lua')

/*-----------------------------------------------------------------------------------------------------------------
	Sprite States
------------------------------------------------------------------------------------------------------------------*/

local SPRITE_STATE_WALK = 1
local SPRITE_STATE_AIM  = 2	
local SPRITE_STATE_FIRE = 3
local SPRITE_STATE_PAIN = 4
local SPRITE_STATE_DEATH = 5

/*-----------------------------------------------------------------------------------------------------------------
	AI States
------------------------------------------------------------------------------------------------------------------*/
local STATE_IDLE   = 0
local STATE_WANDER = 1
local STATE_CHASE  = 2
local STATE_ATTACK = 3
local STATE_PAIN   = 4
/*-----------------------------------------------------------------------------------------------------------------
	Values
------------------------------------------------------------------------------------------------------------------*/

ENT.SoundAlert = Sound("DOOM/cyb_roar.wav")
ENT.SoundPain = Sound("DOOM/DSDMPAIN.wav")
ENT.SoundDeath = Sound("DOOM/DSCYBDTH.wav")
ENT.TaskFinishTime = 0
ENT.Sprite = NULL
ENT.State = STATE_IDLE
ENT.Enemy = NULL
ENT.AttackRadius = 0
ENT.LastTargetAquired = 0
ENT.PainChance = 0.0781
ENT.Relationships = {
						["player"] = "D_HT",
						["npc_citizen"] = "D_HT",
						["npc_monk"] = "D_HT",
						["npc_kleiner"] = "D_HT",
						["npc_alyx"] = "D_HT",
						["npc_eli"] = "D_HT",
						["npc_gman"] = "D_HT",
						["npc_magnusson"] = "D_HT",
						["npc_barney"] = "D_HT",
						["npc_mossman"] = "D_HT",
						["npc_breen"] = "D_HT",
						["npc_dog"] = "D_HT",
						["npc_vortigaunt"] = "D_HT",
						["npc_crow"] = "D_HT",
						["npc_pigeon"] = "D_HT",
						["npc_seagull"] = "D_HT",
						["npc_barnacle"] = "D_HT"
					}



/*-----------------------------------------------------------------------------------------------------------------
	Schedules
------------------------------------------------------------------------------------------------------------------*/

	local CYB_main = ai_schedule.New("CYB_main")
		CYB_main:EngTask("TASK_WAIT",0.1)
		CYB_main:EngTask("TASK_STOP_MOVING",0)
		CYB_main:EngTask("TASK_FACE_ENEMY",0)
		CYB_main:EngTask("TASK_WAIT",0.1)
		CYB_main:AddTask("Attack",0)
		CYB_main:AddTask("Attack",0)
		CYB_main:AddTask("Attack",0)
		CYB_main:EngTask("TASK_WAIT",0.5)
		CYB_main:EngTask("TASK_GET_PATH_TO_RANDOM_NODE",64)
		CYB_main:EngTask("TASK_RUN_PATH",0)
		CYB_main.DebugName = "CYB_main"
	local CYB_wander = ai_schedule.New("CYB_wander")
		CYB_wander:EngTask("TASK_GET_PATH_TO_RANDOM_NODE",128)
		CYB_wander:EngTask("TASK_WALK_PATH",0)
		CYB_wander:EngTask("TASK_WAIT",math.random(1,2))
		CYB_wander:EngTask("TASK_STOP_MOVING",0)
		CYB_wander.DebugName = "CYB_wander"
	local CYB_chase = ai_schedule.New("CYB_chase")
		CYB_chase:EngTask("TASK_SET_SCHEDULE",SCHED_CHASE_ENEMY)
		CYB_chase:EngTask("TASK_GET_PATH_TO_ENEMY",500)
		CYB_chase:EngTask("TASK_WALK_PATH",0)
		CYB_chase:EngTask("TASK_WAIT_FOR_MOVEMENT",0)
		CYB_chase.DebugName = "CYB_chase"
	local CYB_pain = ai_schedule.New("CYB_pain")
		CYB_pain:EngTask("TASK_STOP_MOVING",0) 
		CYB_pain:AddTask("Flinch",0)
		//CYB_main:EngTask("TASK_STOP_MOVING",0) 
		
		CYB_pain.DebugName = "CYB_pain"
		
/*-----------------------------------------------------------------------------------------------------------------
	Tasks
------------------------------------------------------------------------------------------------------------------*/

	function ENT:TaskStart_Attack(data)
		local en = self:GetEnemy2()
		if !en || !en:IsValid() || (en:IsPlayer() && !en:Alive()) then
			en = self:GetEnemy()||NULL
		end
		if en:IsValid() then
			self:Shoot(GetEntityCenter(en))
			local ang = (en:GetPos()-self:GetPos()):Angle()
			ang.p = 0
			ang.r = 0
			self:SetAngles(ang)
			self.AttackRadius = 100
			//ErrorNoHalt("setting state to STATE_ATTACK in TaskStart_Attack\n")
			self:SetAIState(STATE_ATTACK)
		end
		self.TaskFinishTime = CurTime()+0.5
	end

		function ENT:Task_Attack()
			if self.TaskFinishTime-0.2 < CurTime() then
				self:SetAIState(STATE_IDLE)
				self:SetSpriteState(SPRITE_STATE_AIM)
				if self.TaskFinishTime < CurTime() then
					self.TaskFinishTime = 0
					self:TaskComplete()
				end
			end
		end
		
	function ENT:TaskStart_Flinch(data)
		self:SetAIState(STATE_PAIN)
		self:EmitSound(self.SoundPain)
		self:SetSpriteState(SPRITE_STATE_PAIN)
		self.TaskFinishTime = CurTime()+0.5
		//ErrorNoHalt("Flinched")
	end
		function ENT:Task_Flinch()
			if self.TaskFinishTime < CurTime() then
				self:SetAIState(STATE_CHASE)
				self.TaskFinishTime = 0
				self:TaskComplete()
				self:SetSpriteState(SPRITE_STATE_WALK)
			end
		end
/*-----------------------------------------------------------------------------------------------------------------
	AI
------------------------------------------------------------------------------------------------------------------*/

--[[ debugging shit
/*---------------------------------------------------------
   Name: RunAI - Called from the engine every 0.1 seconds 
---------------------------------------------------------*/
function ENT:RunAI( strExp )

	if ( self:IsRunningBehavior() ) then
		if self.State == STATE_PAIN then print(1) end
		return true
	end
	
	if ( self:DoingEngineSchedule() ) then
		if self.State == STATE_PAIN then print(2) end
		return true
	end

	if ( self.CurrentSchedule ) then
		if self.State == STATE_PAIN then print(3) end
		self:DoSchedule( self.CurrentSchedule )
	end
	

	if ( !self.CurrentSchedule ) then
		if self.State == STATE_PAIN then print(4) end
		self:SelectSchedule()
	end
	
	self:MaintainActivity()

end


local StartScheduleOld = scripted_ents.Get("base_ai").StartSchedule

function ENT:StartSchedule(sched)
	print(sched.DebugName)
	StartScheduleOld(self,sched)
end

]]

	
function ENT:SelectSchedule()
	//ErrorNoHalt("SelectSchedule \n")
	//if (self.State == STATE_PAIN) then
	//	return
	//end
	if (self:GetEnemy2()||NULL):IsValid() then
		if (self:GetEnemy2():GetPos():Distance(self:GetPos()) < self.AttackRadius) && self:GetLoSToEntity(self:GetEnemy2()) then
			self:SetSchedule(SCHED_COMBAT_FACE)
			self:StartSchedule(CYB_main)
			self:SetAIState(STATE_ATTACK)
		else
			//print("Setting schedule to SCHED_CHASE_ENEMY in SelectSchedule")
			self:SetAIState(STATE_CHASE)
			self:StartSchedule(CYB_chase)
		end
	else
		self:StartSchedule(CYB_wander)
		self:SetAIState(STATE_WANDER)
	end
end

function ENT:SetAIState(state)
	//ErrorNoHalt("SetAIState \n")
	self.State = state
	if (state == STATE_WANDER) || (state == STATE_CHASE) then
		self:SetSpriteState(SPRITE_STATE_WALK)
	end
end

function ENT:Initialize()
	self.LastPos = self:GetPos()
	self:SetupSprite()
	self:SetupBody()
	self:SetEnemy2(NULL)
	self:CapabilitiesAdd(CAP_USE|CAP_OPEN_DOORS|CAP_AUTO_DOORS)
	//self:AddRelationship("Player D_HT 99")
	for k,v in pairs(self.Relationships) do --Set up our relationships
		self:AddRelationship(k.." "..v.." 99")
	end
	self.comballs = {}
end

function ENT:SetupSprite()
	self.Sprite = ents.Create("cyberdemon_sprite")
	self.Sprite:SetAngles(self:GetAngles())
	self.Sprite:SetPos(self:GetPos()-Vector(0,0,20))
	self.Sprite:SetParent(self)
	self.Sprite:Spawn()
	self:SetNoDraw(true)
	self:SetColor(0,0,0,0)
	self:DrawShadow(false)
end

function ENT:SetupBody()
	//self:SetMovementActivity(ACT_RUN)
	//self:SetModel("models/doom/cyb.mdl")
	self:SetHullType(HULL_LARGE)
	self:SetHullSizeNormal(true)
	self:SetSolid(SOLID_BBOX)
	self:SetMoveType(MOVETYPE_STEP)
	self:SetHealth(4000)
	self:CapabilitiesRemove(4194304)
	self:CapabilitiesAdd(CAP_MOVE_GROUND|CAP_USE|CAP_AUTO_DOORS|CAP_OPEN_DOORS|CAP_SQUAD)
	self:SetMaxYawSpeed(720)
	self:SetCollisionBounds(Vector(-32,-32,0),Vector(32,32,172))
end

function ENT:Think()
	if (self:GetPos() != self.LastPos) && ((self.State == STATE_WANDER) || (self.State == STATE_CHASE)) then
		local ang = (self:GetPos()-self.LastPos):Angle()
		ang.p = 0
		ang.r = 0
		self:SetAngles(ang)
	end
	self.LastPos = self:GetPos()
	//ErrorNoHalt("Think \n")
	self:SetMovementActivity(ACT_RUN)
	for k,v in ipairs(ents.FindByClass("prop_combine_ball")) do
		if !self.comballs[v] then
			self.comballs[v] = true
			constraint.NoCollide(self,v,0,0)
		end
	end
	//if self:GetEnemy2():IsValid() && (!self:GetEnemy2():IsPlayer() || !self:GetEnemy2():Alive()) then
	//	self:SetEnemy2(NULL)
	//	self:SetEnemy(NULL)
	//end
	if self.State != STATE_ATTACK then --if we're attacking then we've already got our target, don't we?
		self:SearchSphereForEnemy(4096)
	end
	if self.AttackRadius < 4096 then
		self.AttackRadius = self.AttackRadius+32
	end
	self:DropToFloor()
	self:SetPlaybackRate(0) --to keep it from doing that roar for people with HL:S mounted
	self:SetCycle(0)
end

function ENT:GetLoSToEntity(ent)
	if ent:IsValid() then
		local tracep = {}
		tracep.mins = Vector(-16,-16,-16)
		tracep.maxs = Vector(16,16,16)
		tracep.start = GetEntityCenter(self)
		tracep.endpos = GetEntityCenter(ent)
		tracep.mask = MASK_SHOT
		tracep.filter = self
		local tr = util.TraceHull(tracep)
		if tr.Entity == ent then
			return true
		else
			return false
		end
	else
		return false
	end
end

function ENT:SearchSphereForEnemy(radius)
	if (self.LastTargetAquired+3 > CurTime()) then
		return
	end
	//ErrorNoHalt("SearchSphereForEnemy \n")
	local target = NULL
	local dist = radius
	local pos = self:GetPos()
	for k,v in ipairs(ents.FindInSphere(pos,radius)) do
		if (!v:IsPlayer() || (v:Alive() && GetConVarNumber("ai_ignoreplayers") == 0)) && (self:Disposition(v) == D_HT) && (pos:Distance(v:GetPos()) < dist) then --the cybdermon  will not autotarget nearby players when ai_ignoreplayers is 1, but there's a nasty surprise waiting for anyone that thinks they can get away with attacking a defenseless cyberdemon
			target = v
			dist = pos:Distance(v:GetPos())
		end
	end
	if target:IsValid() then
		if (dist < self.AttackRadius) && ((self.State == STATE_CHASE) || (self.State == STATE_WANDER)) && self:GetLoSToEntity(target) then
			self:SetSchedule(SCHED_COMBAT_FACE)
			self:StartSchedule(CYB_main)
			self:SetAIState(STATE_ATTACK)
			//ErrorNoHalt("setting state to STATE_ATTACK in SeachSphereForEnemy\n")
		end
		if (target != (self:GetEnemy2()||NULL)) then
			////ErrorNoHalt(tostring(target).." != "..tostring(self:GetEnemy2()||NULL).."\n")
			if (self:GetEnemy2() == NULL) then
				self:EmitSound(self.SoundAlert)
			end
			self.LastTargetAquired = CurTime()
			self:SetEnemy2(target)
			self:SetEnemy(target)
		end
	end
end

function ENT:SetEnemy2(ent)
	//ErrorNoHalt("SetEnemy2 \n")
	if ent && (ent:IsValid() || (!self.Enemy:IsValid() ||(!self.Enemy:IsPlayer() || !self.Enemy:Alive()))) then
		self.Enemy = ent
		self:SetEnemy(ent)
	end
end

function ENT:GetEnemy2()
	//ErrorNoHalt("GetEnemy2 \n")
	return self.Enemy||NULL
end

function GetEntityCenter(ent)
	//ErrorNoHalt("GetEntityCenter \n")
	return ent:GetPos()+ent:OBBCenter()
end

function ENT:Shoot(target) --takes a vector, not an entity
	//ErrorNoHalt("Shoot \n")
	local shootpos = self:GetPos()+Vector(0,0,85)
	local proj = ents.Create("DOOM_projectile_rocket")
	proj.Owner = self
	proj:SetPos(shootpos)
	proj:SetAngles(self:GetAngles())
	proj:SetOwner(self)
	proj:Spawn()
	proj:GetPhysicsObject():Wake()
	proj:GetPhysicsObject():EnableDrag(false)
	proj:GetPhysicsObject():EnableGravity(false)
	proj:GetPhysicsObject():SetVelocity((target-shootpos)*2500)
	proj.VelCap = 2500
	proj:GetPhysicsObject():SetBuoyancyRatio(0)
	self:EmitSound("DOOM/rocket_fire.wav",100,100)
	self:SetSpriteState(SPRITE_STATE_FIRE)
end

function ENT:SetSpriteState(state)
	self.Sprite.dt.State = state
	//ErrorNoHalt("SetSpriteState \n")
	//umsg.Start("cybsprite")
	//	umsg.Entity(self.Sprite)
	//	umsg.Char(state)
	//umsg.End()
end

function ENT:Die(dmginfo)
	self:EmitSound(self.SoundDeath)
	self:SetSpriteState(SPRITE_STATE_DEATH)
	self.Sprite.dt.DieAnimTime = CurTime()+2
	self.Sprite:Fire("Kill",1,300)
	self.Sprite:SetParent()
	//hook.Call("OnNPCKilled",self,dmginfo:GetAttacker(),dmginfo:GetInflictor()) --doesn't work, weird
	--Basically all of the following code in this function was grabbed from Garry's OnNPCKilled hook in the base gamemode. This is for two reasons:
	--1. The cyberdemon behaves a little differently from other NPCs mostly because of the fact that it isn't supposed to use a ragdoll, I'd much rather keep it separate from other NPCs
	--2. Calling the hook doesn't seem to work
	local attacker = dmginfo:GetAttacker()
	local AttackerClass = "worldspawn"
	if attacker:IsValid() then
		AttackerClass = attacker:GetClass()
	end
	local inflictor = dmginfo:GetInflictor()
	local InflictorClass = "worldspawn"
	if inflictor:IsValid() then
		InflictorClass = inflictor:GetClass()
	end
	if ( attacker && attacker:IsValid() && attacker:IsPlayer() ) then
		umsg.Start("PlayerKilledNPC")
			umsg.String(self:GetClass())
			umsg.String(InflictorClass)
			umsg.Entity(attacker)
		umsg.End()	
	elseif ( attacker && attacker:IsValid() && attacker:IsNPC()) then
		umsg.Start("NPCKilledNPC")	
			umsg.String(self:GetClass())
			umsg.String(InflictorClass)
			umsg.String(AttackerClass)
		umsg.End()
	end
	self:Remove()
end

/*-----------------------------------------------------------------------------------------------------------------
	General
------------------------------------------------------------------------------------------------------------------*/

function ENT:OnTakeDamage(dmg)
	if dmg:GetAttacker():IsValid() then
		if dmg:GetAttacker():GetClass() == "npc_cyberdemon" then --no inflighting or self damage
			return false
		end
		self:SetEnemy(dmg:GetAttacker())
		self:SetEnemy2(dmg:GetAttacker())
		if math.random(0,10000)/10000 < self.PainChance then
			self:TaskComplete()
			self:StartSchedule(CYB_pain)
		end
		if !dmg:IsExplosionDamage() && !dmg:IsDamageType(DMG_CRUSH) && !dmg:IsDamageType(DMG_POISON) then
			if self:Health() < dmg:GetDamage() then
				self:Die(dmg)
			end
			self:SetHealth(self:Health()-dmg:GetDamage())
		end
	end
end

hook.Add("ScaleNPCDamage","nocybdmgscale",function(npc,hitgroup,dmginfo) if npc:GetClass() == "npc_cyberdemon" then return true end end) --use this so headshots don't affect it

function ENT:PhysicsCollide()
end 

function ENT:StartTouch()
end

function ENT:Touch(hitent)
end

function ENT:EndTouch()
end

hook.Add("OnEntityCreated","CYBFear",function(ent)
	if ent:IsNPC() then
		for k,v in ipairs(ents.GetAll()) do
			if v:IsNPC() then
				for i,j in ipairs(ents.FindByClass("npc_cyberdemon")) do
					v:AddEntityRelationship(j,D_FR,99)
				end
			end
		end
	end
end)