include ("shared.lua")

SWEP.Category = "DOOM weapons"
SWEP.PrintName = "The BFG9000"
if GetConVarNumber("hud_fastswitch") == 0 then --for some reason slot 7 works when you have fastswitch enabled but it doesn't when you don't?
	SWEP.Slot = 5
	SWEP.SlotPos = 1
else
	SWEP.Slot = 6
	SWEP.SlotPos = 0
end
SWEP.shoottime = 0
SWEP.mat = Material("sprites/DOOM/v_BFG")
SWEP.frames = {0,1,2,3,1}
SWEP.wmat = Material("sprites/DOOM/w_bfg")
SWEP.tex = surface.GetTextureID("sprites/DOOM/w_bfg_menu")
SWEP.lastfired = 0

function SWEP:ViewModelDrawn()
	render.SetMaterial(self.mat)
	if self.shoottime == 0 then
		local col = doom.GetColor(self:GetPos())
		self.mat:SetMaterialVector("$color",col)
		self.mat:SetMaterialInt("$frame",0)
		local basepos = EyePos()+EyeVector()*12-EyeAngles():Up()*(3+math.abs(math.sin(self.Owner.sway)))+EyeAngles():Right()*(math.cos(self.Owner.sway)*2)+doom.ViewOffset
		local basepos2 = EyePos()+EyeVector()*12-EyeAngles():Up()*3+doom.ViewOffset
		basepos = LerpVector(math.Clamp((self.Owner.lastmovetime+0.25-SysTime())*4,0,1),basepos2,basepos)
		local right = EyeAngles():Right()*8
		local up = EyeAngles():Up()*4
		render.DrawQuad(basepos-right+up,basepos+right+up,basepos+right-up,basepos-right-up)
		//render.DrawSprite(EyePos()+EyeVector()*16-EyeAngles():Up()*(4+math.abs(math.sin(self.Owner.sway)))+EyeAngles():Right()*(math.cos(self.Owner.sway)*2),32,16,Color(255,255,255,255))
	else
		local fr = self.frames[math.Clamp( math.Round(6-((self.shoottime-CurTime())*5.834)),1,5)]
		if fr < 2 then
			local col = doom.GetColor(self:GetPos())
			self.mat:SetMaterialVector("$color",col)
		else
			self.mat:SetMaterialVector("$color",Vector(1,1,1))
		end
		self.mat:SetMaterialInt("$frame",fr)
		//print(fr)
		local basepos = EyePos()+EyeVector()*12-EyeAngles():Up()*3+doom.ViewOffset
		local right = EyeAngles():Right()*8
		local up = EyeAngles():Up()*4
		//render.DrawSprite(EyePos()+EyeVector()*16-EyeAngles():Up()*4,32,16,Color(255,255,255,255))
		render.DrawQuad(basepos-right+up,basepos+right+up,basepos+right-up,basepos-right-up)
	end
end

function SWEP:Think()
	if CurTime() > self.shoottime+0.5 then
		self.shoottime = 0
	end
end

function SWEP:PrimaryAttack()
	if !SinglePlayer() && (self.Owner:GetAmmoCount("Battery") < 40) || (CurTime() < self.lastfired+1.5) then
		return
	end
	self.shoottime = CurTime()+1
	self.lastfired = CurTime()
	self.Weapon:SetNextPrimaryFire(CurTime()+1.5)
end

function SWEP:DoShootAnim()
	self.shoottime = CurTime()+1
end