include ("shared.lua")
SWEP.PrintName = "Chaingun";
SWEP.Slot = 3;
SWEP.SlotPos = 0;
SWEP.shoottime = 0
SWEP.mat = Material("sprites/DOOM/v_chaingun")
SWEP.frame = 1
SWEP.nextfire = 0
SWEP.shoottime2 = 0
SWEP.tex = surface.GetTextureID("sprites/DOOM/w_chaingun_menu")
SWEP.lastfired = 0

function SWEP:ViewModelDrawn()
	self.Owner.sway = self.Owner.sway or 0
	render.SetMaterial(self.mat)
	if self.shoottime == 0 then
		local col = doom.GetColor(self:GetPos())
		self.mat:SetMaterialVector("$color",col)
		self.mat:SetMaterialInt("$frame",0)
		local basepos = EyePos()+EyeVector()*12-EyeAngles():Up()*(3+math.abs(math.sin(self.Owner.sway)))+EyeAngles():Right()*(math.cos(self.Owner.sway)*2)+doom.ViewOffset
		local basepos2 = EyePos()+EyeVector()*12-EyeAngles():Up()*3+doom.ViewOffset
		basepos = LerpVector(math.Clamp((self.Owner.lastmovetime+0.25-SysTime())*4,0,1),basepos2,basepos)
		local right = EyeAngles():Right()*4
		local up = EyeAngles():Up()*4
		render.DrawQuad(basepos-right+up,basepos+right+up,basepos+right-up,basepos-right-up)
		//render.DrawSprite(EyePos()+EyeVector()*16-EyeAngles():Up()*(4+math.abs(math.sin(self.Owner.sway)))+EyeAngles():Right()*(math.cos(self.Owner.sway)*2),32,16,Color(255,255,255,255))
	elseif CurTime()+0.09 < self.shoottime then
		//local fr = math.Clamp(1+(self.shoottime-CurTime())*20,1,2)
		local fr = math.Clamp(3-math.ceil((self.shoottime2-CurTime())*10),1,2)
		//local fr = self.frame+1
		if fr == 0 then
			local col = doom.GetColor(self:GetPos())
			self.mat:SetMaterialVector("$color",col)
		else
			self.mat:SetMaterialVector("$color",Vector(1,1,1))
		end
		self.mat:SetMaterialInt("$frame",fr)
		local basepos = EyePos()+EyeVector()*12-EyeAngles():Up()*3+doom.ViewOffset
		local right = EyeAngles():Right()*4
		local up = EyeAngles():Up()*4
		//render.DrawSprite(EyePos()+EyeVector()*16-EyeAngles():Up()*4,32,16,Color(255,255,255,255))
		render.DrawQuad(basepos-right+up,basepos+right+up,basepos+right-up,basepos-right-up)
	else
		local col = doom.GetColor(self:GetPos())
		self.mat:SetMaterialVector("$color",col)
		self.mat:SetMaterialInt("$frame",0)
		local basepos = EyePos()+EyeVector()*12-EyeAngles():Up()*3+doom.ViewOffset
		local right = EyeAngles():Right()*4
		local up = EyeAngles():Up()*4
		//render.DrawSprite(EyePos()+EyeVector()*16-EyeAngles():Up()*4,32,16,Color(255,255,255,255))
		render.DrawQuad(basepos-right+up,basepos+right+up,basepos+right-up,basepos-right-up)
	end
end

function SWEP:Think()
	if CurTime() > self.shoottime+0.2 then
		self.shoottime = 0
	end
	if !SinglePlayer() && (self.shoottime2 != 0) && (self.lastfired+0.1 < CurTime()) then
		self:Shoot()
		self.shoottime2 = 0
		self.firstshot = false
	end
end

function SWEP:PrimaryAttack()
	if CurTime() < self.lastfired+0.1 then
		return
	end
	if CurTime() > self.lastfired+0.12 then
		self.firstshot = true
	end
	self:Shoot()
	self.nextfire = CurTime()+0.22
	self.shoottime2 = CurTime()+0.1
	self.Weapon:SetNextPrimaryFire(CurTime()+0.2)
end

function SWEP:Shoot()
	if (self.Owner:GetAmmoCount("Pistol") < 1) then
		return
	end
	local tracep = {}
	tracep.start = self.Owner:GetShootPos()
	tracep.filter = self.Owner
	local tr = {}
	if !self.firstshot then
		local right = self.Owner:GetAimVector():Angle():Right()
		tracep.endpos = self.Owner:GetShootPos()+((self.Owner:GetAimVector()+right*math.Rand(-0.05,0.05)):GetNormalized()*4096)
	else
		tracep.endpos = self.Owner:GetShootPos()+self.Owner:GetAimVector()*4000
	end
	
	tr = util.TraceLine(tracep)
		if tr.Entity && tr.Entity:IsValid() && (tr.Entity:IsPlayer() || tr.Entity:IsNPC()) then
			local edata = EffectData()
			edata:SetOrigin(tr.HitPos)
			edata:SetEntity(self)
			util.Effect("DBlood",edata,true)
		elseif !tr.HitSky then
			local edata = EffectData()
			edata:SetOrigin(tr.HitPos)
			edata:SetEntity(self)
			util.Effect("DPuff",edata,true)
		end
	self.lastfired = CurTime()
	self.shoottime = CurTime()+0.3
	self.frame = 1-self.frame
	//self.firstshot = false
end

function SWEP:DoShootAnim()
	self.shoottime = CurTime()+0.3
	self.frame = 1-self.frame
	self.firstshot = false
	if CurTime() > self.nextfire then
		self.firstshot = true
	end
	self.nextfire = CurTime()+0.3
	if (self.shoottime2 < CurTime()) then
		self.shoottime2 = CurTime()+0.2
	end
	self.Weapon:SetNextPrimaryFire(CurTime()+0.2)
end