include ("shared.lua")

SWEP.PrintName = "Chainsaw"
SWEP.Slot = 0
SWEP.SlotPos = 0
SWEP.shoottime = 0
SWEP.DrawAmmo = false
SWEP.mat = Material("sprites/DOOM/v_chainsaw")
SWEP.frame = 0
SWEP.nextframe = 0
SWEP.tex = surface.GetTextureID("sprites/DOOM/w_chainsaw_menu")
SWEP.lastfired = 0

function SWEP:ViewModelDrawn()
	local col = doom.GetColor(self:GetPos())
	self.mat:SetMaterialVector("$color",col)
	self.Owner.sway = self.Owner.sway or 0
	render.SetMaterial(self.mat)
	if !self.Owner:KeyDown(IN_ATTACK) then
		self.mat:SetMaterialInt("$frame",self.frame)
		local basepos = EyePos()+EyeVector()*12-EyeAngles():Up()*(2+math.abs(math.sin(self.Owner.sway)))+EyeAngles():Right()*(math.cos(self.Owner.sway)*2)+doom.ViewOffset
		local basepos2 = EyePos()+EyeVector()*12-EyeAngles():Up()*2+doom.ViewOffset
		basepos = LerpVector(math.Clamp((self.Owner.lastmovetime+0.25-SysTime())*4,0,1),basepos2,basepos)
		local right = EyeAngles():Right()*8
		local up = EyeAngles():Up()*4
		render.DrawQuad(basepos-right+up,basepos+right+up,basepos+right-up,basepos-right-up)
		//render.DrawSprite(EyePos()+EyeVector()*16-EyeAngles():Up()*(4+math.abs(math.sin(self.Owner.sway)))+EyeAngles():Right()*(math.cos(self.Owner.sway)*2),32,16,Color(255,255,255,255))
	else
		self.mat:SetMaterialInt("$frame",self.frame+2)
		local basepos = EyePos()+EyeVector()*12-EyeAngles():Up()*2+doom.ViewOffset
		local right = EyeAngles():Right()*8
		local up = EyeAngles():Up()*4
		//render.DrawSprite(EyePos()+EyeVector()*16-EyeAngles():Up()*4,32,16,Color(255,255,255,255))
		render.DrawQuad(basepos-right+up,basepos+right+up,basepos+right-up,basepos-right-up)
	end
	if CurTime() > self.shoottime+0.6 then
		self.shoottime = 0
	end
	if self.nextframe < CurTime() then
		self.frame = 1-self.frame
		self.nextframe = CurTime()+0.2
	end
end


function SWEP:PrimaryAttack()
	if CurTime() < self.lastfired+0.1 then
		return
	end
	self.shoottime = CurTime()+0.1
	self.lastfired = CurTime()
	self.Weapon:SetNextPrimaryFire(CurTime()+0.1)
	local tracep = {}
	tracep.start = self.Owner:GetShootPos()
	tracep.filter = self.Owner
	tracep.mask = MASK_SHOT
	tracep.endpos = self.Owner:GetShootPos()+self.Owner:GetAimVector()*60
	tr = util.TraceLine(tracep)
	if tr.Entity && tr.Entity:IsValid() && (tr.Entity:IsPlayer() || tr.Entity:IsNPC()) then
		local ply = self.Owner
		local edata = EffectData()
		edata:SetEntity(self)
		edata:SetOrigin(tr.HitPos)
		util.Effect("DBlood",edata)
		return
	end
	if tr.Hit && !tr.HitSky then
		local edata = EffectData()
		edata:SetEntity(self)
		edata:SetOrigin(tr.HitPos)
		util.Effect("DPuff",edata)
	end
end

function SWEP:DoShootAnim()
	self.shoottime = CurTime()+0.1
end

function SWEP:CustomAmmoDisplay()
end