AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")
include("shared.lua")
SWEP.Weight = 5;
SWEP.shoottime = 0
SWEP.nextfire = 0
SWEP.nst = 0
SWEP.lockent = NULL
SWEP.tracechances = 0
SWEP.lasthit = 0
SWEP.ItemClass = "doom_wep_chainsaw"

function SWEP:Initialize()
	self:SetWeaponHoldType("ar2")
	self.lock = Vector(0,0,0)
end

function SWEP:Deploy()
	self.isactive = true
	if !self.Owner.DOOM_CSaw1 then
		self.Owner.DOOM_CSaw1 = CreateSound(self.Owner,"DOOM/DSSAWIDL.wav")
		self.Owner.DOOM_CSaw2 = CreateSound(self.Owner,"DOOM/DSSAWFUL.wav")
		self.Owner.DOOM_CSaw3 = CreateSound(self.Owner,"DOOM/DSSAWHIT.wav")
	end
	self.nst = CurTime()+1.2
	self.Owner:EmitSound("DOOM/DSSAWUP.wav")
	return true
end

function SWEP:Holster()
	self.isactive = false
	self.Owner.DOOM_CSaw3:Stop()
	self.Owner.DOOM_CSaw2:Stop()
	self.Owner.DOOM_CSaw1:Stop()
	return true
end

local dmg = DamageInfo()
local tracep = {}
tracep.mask = MASK_SHOT
tracep.mins = Vector(-6,-6,-6)
tracep.maxs = Vector(6,6,6)

function SWEP:PrimaryAttack()
	if SinglePlayer() then
		umsg.Start("d_cl_fire")
		umsg.End()
	end
	self.Owner.DOOM_CSaw1:Stop()
	self.nextfire = CurTime()+0.1
	self.Weapon:SetNextPrimaryFire(CurTime()+0.1)
	
	tracep.start = self.Owner:GetShootPos()
	tracep.filter = self.Owner
	
	tracep.endpos = self.Owner:GetShootPos()+self.Owner:GetAimVector()*60
	local tr = util.TraceLine(tracep)
	if tr.Hit || (self.tracechances > 0) then
		if !tr.Entity || (tr.Entity && !tr.Entity:IsValid()) then
			if self.lockent && self.lockent:IsValid() && (self.Owner:GetPos():Distance(self.lockent:GetPos()) > 70) then
				self.tracechances = 1
			end
			tr.Entity = self.lockent
			self.tracechances = self.tracechances-1
		else
			self.tracechances = 40
		end
		dmg:SetAttacker(self.Owner)
		dmg:SetInflictor(self)
		dmg:SetDamage(math.random(2,20))
		dmg:SetDamageForce(tr.Normal*-5000)
		dmg:SetDamageType(DMG_SLASH)
		if self.lockent:IsValid() && (self.lockent:Health() > 0) then
			local lookdest = self.lockent:LocalToWorld(self.lock)
			//lookdest.z = (lookdest.z+self.Owner:GetShootPos().z)/2
			self.Owner:SnapEyeAngles((lookdest-self.Owner:GetShootPos()):Angle())
		end
		if tr.Entity && tr.Entity:IsValid() && (tr.Entity:IsPlayer() || tr.Entity:IsNPC()) && (tr.Entity:Health() > 0) then
			self.lockent = tr.Entity
			local ply = self.Owner
				local edata = EffectData()
				edata:SetEntity(self)
				edata:SetOrigin(tr.HitPos)
				util.Effect("DBlood",edata)
			//tr.Entity:TakeDamage(math.random(2,20),ply,self)
			tr.Entity:DispatchTraceAttack(dmg,tracep.start,tracep.endpos)
			if self.lock == vector_origin then
				self.lock = tr.Entity:WorldToLocal(tr.HitPos)
			end
			self.Owner.DOOM_CSaw2:Stop()
			self.Owner.DOOM_CSaw3:Stop()
			self.Owner.DOOM_CSaw3:Play()
			self.hit = true
			local dir = tr.Entity:GetPos()+self.lock-self.Owner:GetShootPos()
			dir = tr.Entity:GetPos()+self.lock-self.Owner:GetShootPos()-Vector(0,0,dir.z)
			self.Owner:SetVelocity(dir:Normalize()*300)
			self.lasthit = CurTime()
			return
		end
		if tr.Hit && !tr.HitSky then
			local edata = EffectData()
			edata:SetEntity(self)
			edata:SetOrigin(tr.HitPos)
			util.Effect("DPuff",edata)
		end
		if tr.Entity && tr.Entity:IsValid() then
			//tr.Entity:TakeDamage(math.random(2,20),ply,self)
			tr.Entity:DispatchTraceAttack(dmg,tracep.start,tracep.endpos)
		end
		self.hit = false
	else
		self.lock.x = 0
		self.lock.y = 0
		self.lock.z = 0
		self.hit = false
	end
end

function SWEP:Think()
	if self.lasthit < CurTime()-0.3 then
		self.lockent = NULL
	end
	if !self.Owner:KeyDown(IN_ATTACK) && (self.nst < CurTime()) then
		self.Owner.DOOM_CSaw3:Stop()
		self.Owner.DOOM_CSaw2:Stop()
		self.Owner.DOOM_CSaw1:Stop()
		self.Owner.DOOM_CSaw1:Play()
		self.nst = CurTime()+0.2
	elseif self.Owner:KeyDown(IN_ATTACK) && !self.hit && (self.nst < CurTime()) then
		self.Owner.DOOM_CSaw3:Stop()
		self.Owner.DOOM_CSaw2:Stop()
		self.Owner.DOOM_CSaw1:Stop()
		self.Owner.DOOM_CSaw2:Play()
		self.nst = CurTime()+0.075
	end
end

function SWEP:OnRemove()
	if self.isactive && !self.madeitem then
		local gun = ents.Create("doom_wep_chainsaw")
		gun:SetPos(self:GetPos())
		gun:Spawn()
		gun:SetMoveType(MOVETYPE_VPHYSICS)
		gun:GetPhysicsObject():SetVelocity(Vector(0,0,300))
		self.madeitem = true
	end
	if self.Owner.DOOM_CSaw3 then
		self.Owner.DOOM_CSaw3:Stop()
	end
	if self.Owner.DOOM_Saw2 then
		self.Owner.DOOM_CSaw2:Stop()
	end
	if self.Owner.DOOM_Saw2 then
		self.Owner.DOOM_CSaw1:Stop()
	end
end