include ("shared.lua")

SWEP.PrintName = "Fists";
SWEP.Slot = 0;
SWEP.SlotPos = 0;
SWEP.DrawAmmo = false;
SWEP.shoottime = 0
SWEP.mat = Material("sprites/DOOM/v_fists")
SWEP.frames = {1,2,3,2,1}
SWEP.punchtime = 0
SWEP.lastfired = 0
SWEP.tex = surface.GetTextureID("sprites/doom/DG1Grin")

function SWEP:ViewModelDrawn()
	local col = doom.GetColor(self:GetPos())
	self.mat:SetMaterialVector("$color",col)
	self.Owner.sway = self.Owner.sway or 0
	render.SetMaterial(self.mat)
	if self.shoottime == 0 then
		self.mat:SetMaterialInt("$frame",0)
		local basepos = EyePos()+EyeVector()*12-EyeAngles():Up()*(math.abs(math.sin(self.Owner.sway))+2)+EyeAngles():Right()*(math.cos(self.Owner.sway)*2)+doom.ViewOffset
		local basepos2 = EyePos()+EyeVector()*12-EyeAngles():Up()*2+doom.ViewOffset
		basepos = LerpVector(math.Clamp((self.Owner.lastmovetime+0.25-SysTime())*4,0,1),basepos2,basepos)
		local right = EyeAngles():Right()*8
		local up = EyeAngles():Up()*4
		render.DrawQuad(basepos-right+up,basepos+right+up,basepos+right-up,basepos-right-up)
		//render.DrawSprite(EyePos()+EyeVector()*16-EyeAngles():Up()*(4+math.abs(math.sin(self.Owner.sway)))+EyeAngles():Right()*(math.cos(self.Owner.sway)*2),32,16,Color(255,255,255,255))
	else
		local fr = self.frames[math.Clamp(math.Round(6-((self.shoottime-CurTime())*10)),1,5)]
		self.mat:SetMaterialInt("$frame",fr)
		local basepos = EyePos()+EyeVector()*12-EyeAngles():Up()*2+doom.ViewOffset
		local right = EyeAngles():Right()*8
		local up = EyeAngles():Up()*4
		//render.DrawSprite(EyePos()+EyeVector()*16-EyeAngles():Up()*4,32,16,Color(255,255,255,255))
		render.DrawQuad(basepos-right+up,basepos+right+up,basepos+right-up,basepos-right-up)
	end
end

function SWEP:Think()
	if CurTime() > self.shoottime+0.6 then
		self.shoottime = 0
	end
	if (self.punchtime != 0) && (CurTime() > self.punchtime) then
		self:Punch()
		self.punchtime = 0
	end
end

function SWEP:PrimaryAttack()
	if CurTime() < self.lastfired+0.5 then
		return
	end
	self.punchtime = CurTime()+0.2
	self.shoottime = CurTime()+0.6
	self.lastfired = CurTime()
	self.Weapon:SetNextPrimaryFire(CurTime()+0.5)
end


local hullmins = Vector(-16,-16,-16)
local hullmaxs = Vector(16,16,16)

function SWEP:Punch()
	local tracep = {}
	tracep.start = self.Owner:GetShootPos()
	tracep.filter = self.Owner
	tracep.mask = MASK_SHOT
	tracep.endpos = self.Owner:GetShootPos()+self.Owner:GetAimVector()*60
	tracep.mins = hullmins
	tracep.maxs = hullmaxs
	tr = util.TraceHull(tracep)
	if tr.Hit then
		if tr.Entity && tr.Entity:IsValid() && (tr.Entity:IsPlayer() || tr.Entity:IsNPC()) then
			local edata = EffectData()
			edata:SetEntity(self)
			edata:SetOrigin(tr.HitPos)
			util.Effect("DBlood",edata)
		elseif !tr.HitSky then
			local edata = EffectData()
			edata:SetEntity(self)
			edata:SetOrigin(tr.HitPos)
			util.Effect("DPuff",edata)
		end
	end
end

function SWEP:DoShootAnim()
	self.punchtime = CurTime()+0.2
	self.shoottime = CurTime()+0.6
end

function SWEP:CustomAmmoDisplay()
end