include ("shared.lua")

SWEP.PrintName = "Pistol";
SWEP.Slot = 1;
SWEP.SlotPos = 1;
SWEP.DrawAmmo = true;
SWEP.shoottime = 0
SWEP.mat = Material("sprites/DOOM/v_pistol")
SWEP.tex = surface.GetTextureID("sprites/DOOM/w_pistol_menu")
SWEP.frames = {0,1,3,5,4,0,0}
SWEP.lastfired = 0

function SWEP:ViewModelDrawn()
	self.Owner.sway = self.Owner.sway or 0
	render.SetMaterial(self.mat)
	if self.shoottime == 0 then
		local col = doom.GetColor(self:GetPos())
		self.mat:SetMaterialVector("$color",col)
		self.mat:SetMaterialInt("$frame",0)
		local basepos = EyePos()+EyeVector()*12-EyeAngles():Up()*(math.abs(math.sin(self.Owner.sway))+2)+EyeAngles():Right()*(math.cos(self.Owner.sway)*2)+doom.ViewOffset
		local basepos2 = EyePos()+EyeVector()*12-EyeAngles():Up()*2+doom.ViewOffset
		basepos = LerpVector(math.Clamp((self.Owner.lastmovetime+0.25-SysTime())*4,0,1),basepos2,basepos)
		local right = EyeAngles():Right()*4
		local up = EyeAngles():Up()*4
		render.DrawQuad(basepos-right+up,basepos+right+up,basepos+right-up,basepos-right-up)
		//render.DrawSprite(EyePos()+EyeVector()*16-EyeAngles():Up()*(4+math.abs(math.sin(self.Owner.sway)))+EyeAngles():Right()*(math.cos(self.Owner.sway)*2),32,16,Color(255,255,255,255))
	else
		local fr = self.frames[math.Clamp(math.Round(7-((self.shoottime-CurTime())*10)),1,7)]
		if fr != 1 then
			local col = doom.GetColor(self:GetPos())
			self.mat:SetMaterialVector("$color",col)
		else
			self.mat:SetMaterialVector("$color",Vector(1,1,1))
		end
		self.mat:SetMaterialInt("$frame",fr)
		local basepos = EyePos()+EyeVector()*12-EyeAngles():Up()*2+doom.ViewOffset
		local right = EyeAngles():Right()*4
		local up = EyeAngles():Up()*4
		//render.DrawSprite(EyePos()+EyeVector()*16-EyeAngles():Up()*4,32,16,Color(255,255,255,255))
		render.DrawQuad(basepos-right+up,basepos+right+up,basepos+right-up,basepos-right-up)
	end
end

function SWEP:Think()
	if CurTime() > self.shoottime+0.5 then
		self.shoottime = 0
	end
end

function SWEP:PrimaryAttack()
	if (!SinglePlayer() && (self.Owner:GetAmmoCount("Pistol") < 1)) ||  (CurTime() < self.lastfired+0.4) then
		return
	end
	self.Weapon:SetNextPrimaryFire(CurTime()+0.4)
	local tracep = {}
	tracep.start = self.Owner:GetShootPos()
	tracep.filter = self.Owner
	tracep.mask = MASK_SHOT
	local tr = {}
	if CurTime() < self.lastfired+0.42 then
		local right = self.Owner:GetAimVector():Angle():Right()
		tracep.endpos = self.Owner:GetShootPos()+((self.Owner:GetAimVector()+right*math.Rand(-0.05,0.05)):GetNormalized()*4096)
	else
		tracep.endpos = self.Owner:GetShootPos()+self.Owner:GetAimVector()*4000
	end
	tr = util.TraceLine(tracep)
	
	if tr.Entity && tr.Entity:IsValid() and (tr.Entity:IsPlayer() || tr.Entity:IsNPC()) then
		local edata = EffectData()
		edata:SetEntity(self)
		edata:SetOrigin(tr.HitPos)
		util.Effect("DBlood",edata)
	elseif !tr.HitSky then
		local edata = EffectData()
		edata:SetEntity(self)
		edata:SetOrigin(tr.HitPos)
		util.Effect("DPuff",edata)
	end
	self.lastfired = CurTime()
	self.shoottime = CurTime()+0.5
end


function SWEP:DoShootAnim()
	self.shoottime = CurTime()+0.5
end