include ("shared.lua")

SWEP.PrintName = "Plasma Gun"
SWEP.Slot = 5
SWEP.SlotPos = 0
SWEP.DrawAmmo = true
SWEP.shoottime = 0
SWEP.mat = Material("sprites/DOOM/v_plasmagun")
SWEP.frames = {1,2,0,3,3,3,3}
SWEP.shoottime = 0
SWEP.nss = 0
SWEP.nse = 0
SWEP.tex = surface.GetTextureID("sprites/DOOM/w_plasmagun_menu")
SWEP.lastfired = 0

function SWEP:ViewModelDrawn()
	self.Owner.sway = self.Owner.sway or 0
	render.SetMaterial(self.mat)
	if self.shoottime == 0 then
		local col = doom.GetColor(self:GetPos())
		self.mat:SetMaterialVector("$color",col)
		self.mat:SetMaterialInt("$frame",0)
		local basepos = EyePos()+EyeVector()*12-EyeAngles():Up()*(2+math.abs(math.sin(self.Owner.sway)))+EyeAngles():Right()*(math.cos(self.Owner.sway)*2)+doom.ViewOffset
		local basepos2 = EyePos()+EyeVector()*12-EyeAngles():Up()*2+doom.ViewOffset
		basepos = LerpVector(math.Clamp((self.Owner.lastmovetime+0.25-SysTime())*4,0,1),basepos2,basepos)
		local right = EyeAngles():Right()*4
		local up = EyeAngles():Up()*4
		render.DrawQuad(basepos-right+up,basepos+right+up,basepos+right-up,basepos-right-up)
		//render.DrawSprite(EyePos()+EyeVector()*12-EyeAngles():Up()*(4+math.abs(math.sin(self.Owner.sway)))+EyeAngles():Right()*(math.cos(self.Owner.sway)*2),32,16,Color(255,255,255,255))
	else
		local right = EyeAngles():Right()*4
		local up = EyeAngles():Up()*4
		local fr = self.frames[math.Clamp(math.Round(7-((self.shoottime-CurTime())*5.5)),1,7)]
		if (fr == 0) || (fr == 3) then
			local col = doom.GetColor(self:GetPos())
			self.mat:SetMaterialVector("$color",col)
		else
			self.mat:SetMaterialVector("$color",Vector(1,1,1))
		end
		self.mat:SetMaterialInt("$frame",fr)
		local basepos = EyePos()+EyeVector()*12-EyeAngles():Up()*2+doom.ViewOffset
		if fr == 3 then
			basepos = EyePos()+EyeVector()*12-EyeAngles():Up()*2+doom.ViewOffset-(right/2)
		end
		//render.DrawSprite(EyePos()+EyeVector()*12-EyeAngles():Up()*4,32,16,Color(255,255,255,255))
		render.DrawQuad(basepos-right+up,basepos+right+up,basepos+right-up,basepos-right-up)
	end
end

function SWEP:Think()
	if CurTime() > self.shoottime then
		self.shoottime = 0
	end
end

function SWEP:CustomAmmoDisplay()
	self.AmmoDisplay = self.AmmoDisplay or {}
	self.AmmoDisplay.Draw = true
	self.AmmoDisplay.PrimaryClip = self.Weapon.Owner:GetAmmoCount("Battery")
	self.AmmoDisplay.PrimaryAmmo = nil
	return self.AmmoDisplay
end

function SWEP:PrimaryAttack()
	if (CurTime() > self.nse) || (CurTime() < self.nss) then
		if (!SinglePlayer() && (self.Owner:GetAmmoCount("Battery") < 1)) || (CurTime() < self.lastfired+0.09) then
			return
		end
		self.shoottime = CurTime()+1
		self.nss = CurTime()+0.16
		self.nse = CurTime()+0.6
		self.lastfired = CurTime()
		//self.Weapon:SetNextPrimaryFire(CurTime()+0.09)
		local up = self.Owner:GetAimVector():Angle():Up()
		local edata = EffectData()
		edata:SetOrigin(self.Owner:GetShootPos()-up*16)
		edata:SetStart(self.Owner:GetAimVector()*2500)
		edata:SetEntity(self.Owner)
		util.Effect("DPlasma",edata)
	end
end

function SWEP:DoShootAnim()
	self.shoottime = CurTime()+1
	self.nss = CurTime()+0.16
	self.nse = CurTime()+0.6
end