AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")
include("shared.lua")
SWEP.Weight = 6
SWEP.shoottime = 0
SWEP.nss = 0
SWEP.nse = 0
SWEP.lastfired = 0
SWEP.ItemClass = "doom_wep_plasmagun"

d_proj = {}
d_proj.proj = {}
local hullmins = Vector(-5,-5,-5)
local hullmaxs = Vector(5,5,5)

function d_proj.AddProjectile(owner,pos,velocity,inflictor)
	local projtab = {}
	projtab.Owner = owner
	projtab.pos = pos
	projtab.velocity = velocity
	projtab.lasttrace = CurTime()
	projtab.inflictor = inflictor
	local projectile = table.insert(d_proj.proj,projtab)
end

local dmg = DamageInfo()


local tracep = {}
local rem = {}

function d_proj.RunTraces()
	for k,v in ipairs(d_proj.proj) do
		if v.Owner:IsValid() then --I could just reassign the owner ot the world entity but it still causes crashes for some reason..
			local vel = v.velocity*math.max(0,CurTime()-v.lasttrace)
			tracep.start = v.pos
			tracep.filter = v.Owner
			tracep.endpos = v.pos+vel
			tracep.mask = MASK_SHOT
			tracep.mins = hullmins
			tracep.maxs = hullmaxs
			tr = util.TraceHull(tracep)
			if tr.Hit then
				if tr.Entity && tr.Entity:IsValid() then
					local dir = v.velocity:GetNormalized()
					if v.Owner:IsValid() then
						dmg:SetAttacker(v.Owner)
					end
					if v.inflictor:IsValid() then
						dmg:SetInflictor(v.inflictor)
					end
					dmg:SetDamage(math.random(5,40))
					dmg:SetDamageForce(v.velocity:GetNormalized()*1200)
					dmg:SetDamageType(DMG_ENERGYBEAM) --DMG_PLASMA behaves far too strangely to use
					dmg:SetDamagePosition(tr.HitPos)
					tr.Entity:TakeDamageInfo(dmg)
				end
				table.insert(rem,k)
			end
			v.lasttrace = CurTime()
			v.pos = v.pos+vel
		else
			table.insert(rem,k)
		end
	end
	for i=1,#rem do
		table.remove(d_proj.proj,rem[1])
		table.remove(rem,1)
	end
end

timer.Create("D_proj_traces",0.05,0,d_proj.RunTraces)

function SWEP:Initialize()
	self:SetWeaponHoldType("ar2")
	self:SetNPCMinBurst(7)
	self:SetNPCMaxBurst(15)
	self:SetNPCFireRate(0.09)
	self:SetNPCMinRest(0.6)
	self:SetNPCMaxRest(2)
	
end

function SWEP:Holster()
	if self.shoottime < CurTime() then
		self.isactive = false
		return true
	else
		self.Owner:DrawViewModel(true)
		self.Owner:DrawWorldModel(true)
		return false
	end
end

function SWEP:PrimaryAttack()
	if (CurTime() < self.lastfired+0.09) then
		return
	end
	if (CurTime() > self.nse) || (CurTime() < self.nss) then
		if self.Owner:GetAmmoCount("Battery") > 0 then
			self.Owner:RemoveAmmo(1,"Battery")
		else
			return
		end
		self.shoottime = CurTime()+0.09
		self.nss = CurTime()+0.15
		self.nse = CurTime()+0.6
		self.lastfired = CurTime()
		//self.Weapon:SetNextPrimaryFire(CurTime()+0.09)
		local up = self.Owner:GetAimVector():Angle():Up()
		d_proj.AddProjectile(self.Owner,self.Owner:GetShootPos()-up*16,self.Owner:GetAimVector()*2500,self)
		local edata = EffectData()
			if SinglePlayer() then
				edata:SetScale(UnPredictedCurTime())
			end
			edata:SetOrigin(self.Owner:GetShootPos()-up*16)
			edata:SetStart(self.Owner:GetAimVector()*2500)
			edata:SetEntity(self.Owner)
			
			util.Effect("DPlasma",edata)
		if SinglePlayer() then
			umsg.Start("d_cl_fire")
			umsg.End()
		end
	end
end

function SWEP:NPCShoot_Primary(ShootPos,ShootDir)
	local up = ShootDir:Angle():Up()
	d_proj.AddProjectile(self.Owner,ShootPos,ShootDir*2500,self)
	local edata = EffectData()
	edata:SetOrigin(ShootPos)
	edata:SetStart(ShootDir*2500)
	edata:SetEntity(self.Owner)	
	util.Effect("DPlasma",edata)
end

SWEP.NPCShoot_Secondary = SWEP.NPCShoot_Primary