include ("shared.lua")

SWEP.Category = "DOOM weapons"
SWEP.PrintName = "Rocket Launcher"
SWEP.Slot = 4
SWEP.SlotPos = 0
SWEP.DrawAmmo = true
SWEP.shoottime = 0
SWEP.mat = Material("sprites/DOOM/v_RLauncher")
SWEP.tex = surface.GetTextureID("sprites/DOOM/w_RLauncher_menu")
SWEP.lastfired = 0
SWEP.lastfiredsystime = 0

function SWEP:ViewModelDrawn()
	self.Owner.sway = self.Owner.sway or 0
	render.SetMaterial(self.mat)
	if self.shoottime == 0 then
		local col = doom.GetColor(self:GetPos())
		self.mat:SetMaterialVector("$color",col)
		self.mat:SetMaterialInt("$frame",0)
		local basepos = EyePos()+EyeVector()*12-EyeAngles():Up()*(3+math.abs(math.sin(self.Owner.sway)))+EyeAngles():Right()*(math.cos(self.Owner.sway)*2)+doom.ViewOffset
		local basepos2 = EyePos()+EyeVector()*12-EyeAngles():Up()*3+doom.ViewOffset
		basepos = LerpVector(math.Clamp((self.Owner.lastmovetime+0.25-SysTime())*4,0,1),basepos2,basepos)
		local right = EyeAngles():Right()*4
		local up = EyeAngles():Up()*4
		render.DrawQuad(basepos-right+up,basepos+right+up,basepos+right-up,basepos-right-up)
		//render.DrawSprite(EyePos()+EyeVector()*16-EyeAngles():Up()*(4+math.abs(math.sin(self.Owner.sway)))+EyeAngles():Right()*(math.cos(self.Owner.sway)*2),32,16,Color(255,255,255,255))
	else
		local fr = math.Clamp( math.ceil(((SysTime()-self.lastfiredsystime)*9)),1,5)
		if (fr == 0) || (fr > 4) then
			local col = doom.GetColor(self:GetPos())
			self.mat:SetMaterialVector("$color",col)
		else
			self.mat:SetMaterialVector("$color",Vector(1,1,1))
		end
		self.mat:SetMaterialInt("$frame",fr)
		local basepos = EyePos()+EyeVector()*12-EyeAngles():Up()*3+doom.ViewOffset
		local right = EyeAngles():Right()*4
		local up = EyeAngles():Up()*4
		//render.DrawSprite(EyePos()+EyeVector()*16-EyeAngles():Up()*4,32,16,Color(255,255,255,255))
		render.DrawQuad(basepos-right+up,basepos+right+up,basepos+right-up,basepos-right-up)
	end
end

function SWEP:Think()
	if CurTime() > self.shoottime+0.7 then
		self.shoottime = 0
	end
end

function SWEP:PrimaryAttack()
	if (!SinglePlayer() && (self.Owner:GetAmmoCount("RPG_Round") < 1)) || (CurTime() < self.shoottime) then
		return
	end
	self.lastfiredsystime = SysTime()
	self.shoottime = CurTime()+0.57
	self.lastfired = CurTime()
	//self.Weapon:SetNextPrimaryFire(CurTime()+0.57)
end

function SWEP:DoShootAnim()
	self.shoottime = CurTime()+0.57
	self.lastfiredsystime = SysTime()
end