include ("shared.lua")

SWEP.PrintName = "Shotgun"
SWEP.Slot = 2
SWEP.SlotPos = 0
SWEP.DrawAmmo = true
SWEP.shoottime = 0
SWEP.mat = Material("sprites/DOOM/v_shotgun")
SWEP.frames = {0,1,2,3,4,5,4,3,0}
SWEP.tex = surface.GetTextureID("sprites/DOOM/w_shotgun_menu")
SWEP.lastfired = 0

function SWEP:ViewModelDrawn()
self.Owner.sway = self.Owner.sway or 0
	render.SetMaterial(self.mat)
	if self.shoottime == 0 then
		local col = doom.GetColor(self:GetPos())
		self.mat:SetMaterialVector("$color",col)
		self.mat:SetMaterialInt("$frame",0)
		local basepos = EyePos()+EyeVector()*12-EyeAngles():Up()*(math.abs(math.sin(self.Owner.sway))-2)+EyeAngles():Right()*(math.cos(self.Owner.sway)*2)+doom.ViewOffset
		local basepos2 = EyePos()+EyeVector()*12+EyeAngles():Up()*2+doom.ViewOffset
		basepos = LerpVector(math.Clamp((self.Owner.lastmovetime+0.25-SysTime())*4,0,1),basepos2,basepos)
		local right = EyeAngles():Right()*8
		local up = EyeAngles():Up()*8
		render.DrawQuad(basepos-right+up,basepos+right+up,basepos+right-up,basepos-right-up)
		//render.DrawSprite(EyePos()+EyeVector()*16-EyeAngles():Up()*(4+math.abs(math.sin(self.Owner.sway)))+EyeAngles():Right()*(math.cos(self.Owner.sway)*2),32,16,Color(255,255,255,255))
	else
		local fr = self.frames[math.Clamp(math.Round(9-((self.shoottime-CurTime())*9)),1,9)]
		if (fr != 1) && (fr != 2) then
			local col = doom.GetColor(self:GetPos())
			self.mat:SetMaterialVector("$color",col)
		else
			self.mat:SetMaterialVector("$color",Vector(1,1,1))
		end
		self.mat:SetMaterialInt("$frame",fr)
		local basepos = EyePos()+EyeVector()*12+EyeAngles():Up()*2+doom.ViewOffset
		local right = EyeAngles():Right()*8
		local up = EyeAngles():Up()*8
		//render.DrawSprite(EyePos()+EyeVector()*16-EyeAngles():Up()*4,32,16,Color(255,255,255,255))
		render.DrawQuad(basepos-right+up,basepos+right+up,basepos+right-up,basepos-right-up)
	end
end

function SWEP:Think()
	if CurTime() > self.shoottime+0.2 then
		self.shoottime = 0
	end
end

function SWEP:PrimaryAttack()
	if !SinglePlayer() && (self.Owner:GetAmmoCount("Buckshot") < 1) || (CurTime() < self.lastfired+1) then
		return
	end
	local edata = EffectData()
	edata:SetEntity(self.Owner)
	util.Effect("DSGsnd1",edata)
	self.lastfired = CurTime()
	self.Weapon:SetNextPrimaryFire(CurTime()+1)
	self.shoottime = CurTime()+0.7
end

function SWEP:DoShootAnim()
	self.shoottime = CurTime()+0.7
end