AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")
include("shared.lua")
SWEP.Weight = 2;
SWEP.AutoSwitchTo = true
SWEP.AutoSwitchFrom = true
SWEP.shoottime = 0
SWEP.nextfire = 0
SWEP.ItemClass = "doom_wep_shotgun"

function SWEP:Initialize()
	self:SetWeaponHoldType("shotgun")
	self:SetNPCMinBurst(1)
	self:SetNPCMaxBurst(3)
	self:SetNPCFireRate(1)
	self:SetNPCMinRest(1)
	self:SetNPCMaxRest(3)
end

function SWEP:Holster()
	if self.nextfire < CurTime() then
		self.isactive = false
		return true
	else
		self.Owner:DrawViewModel(true)
		self.Owner:DrawWorldModel(true)
		return false
	end
end

local dmg = DamageInfo()

function SWEP:PrimaryAttack()
	if self.Owner:GetAmmoCount("Buckshot") > 0 then
		self.Owner:RemoveAmmo(1,"Buckshot")
	else
		return
	end
	if SinglePlayer() then
		umsg.Start("d_cl_fire")
		umsg.End()
	end
	local edata = EffectData()
		edata:SetEntity(self.Owner)
		edata:SetOrigin(self.Owner:GetShootPos())
		util.Effect("DSGsnd1",edata)
	if !self.Owner then
		return
	end
	local tracep = {}
	tracep.start = self.Owner:GetShootPos()
	tracep.filter = self.Owner
	tracep.mask = MASK_SHOT
	local right = self.Owner:GetAimVector():Angle():Right()
	self.Owner:LagCompensation(true)
	for i=1,7 do
		local tr = {}
		tracep.endpos = self.Owner:GetShootPos()+((self.Owner:GetAimVector()+right*math.Rand(-0.1,0.1)):GetNormalized()*4096)
		tr = util.TraceLine(tracep)
		if tr.Hit then
			if tr.Entity && tr.Entity:IsValid() then
				dmg:SetAttacker(self.Owner)
				dmg:SetInflictor(self)
				dmg:SetDamage(math.random(5,15))
				if tr.Entity:IsNPC() || tr.Entity:IsPlayer() then
					dmg:SetDamageForce(tr.Normal*50000)
				else
					dmg:SetDamageForce(tr.Normal*500)
				end
				dmg:SetDamageType(DMG_BUCKSHOT)
				dmg:SetDamagePosition(tr.HitPos)
				tr.Entity:DispatchTraceAttack(dmg,tracep.start,tracep.endpos)
			end
		end
	end
	self.Owner:LagCompensation(false)
	self.nextfire = CurTime()+1
	self.Weapon:SetNextPrimaryFire(CurTime()+1)
	
end

function SWEP:NPCShoot_Primary(ShootPos,ShootDir)
	if !self.Owner then
		return
	end
	if self.Owner:GetCurrentWeaponProficiency() < WEAPON_PROFICIENCY_VERY_GOOD then
		self.Owner:SetCurrentWeaponProficiency(WEAPON_PROFICIENCY_VERY_GOOD)
	end
	local edata = EffectData()
		edata:SetEntity(self.Owner)
		edata:SetOrigin(ShootPos)
		edata:SetNormal(ShootDir)
		util.Effect("DSGsnd1",edata)
	local tracep = {}
	tracep.start = self.Owner:GetShootPos()
	tracep.filter = self.Owner
	tracep.mask = MASK_SHOT
	local right = self.Owner:GetAimVector():Angle():Right()
	for i=1,7 do
		local tr = {}
		tracep.endpos = ShootPos+((ShootDir+right*math.Rand(-0.1,0.1)):GetNormalized()*4096)
		tr = util.TraceLine(tracep)
		if tr.Hit then
			if tr.Entity && tr.Entity:IsValid() then
				dmg:SetAttacker(self.Owner)
				dmg:SetInflictor(self)
				dmg:SetDamage(math.random(5,15))
				if tr.Entity:IsNPC() || tr.Entity:IsPlayer() then
					dmg:SetDamageForce(tr.Normal*50000)
				else
					dmg:SetDamageForce(tr.Normal*500)
				end
				dmg:SetDamageType(DMG_BUCKSHOT)
				dmg:SetDamagePosition(tr.HitPos)
				tr.Entity:DispatchTraceAttack(dmg,tracep.start,tracep.endpos)
			end
		end
	end
end